var deps = ['H5PModules/Ajax', 'H5PModules/Storage', '../libs/template', 'H5PModules/Upload-image',
	'../libs/RegExps', '../libs/mui.min', '../libs/jquery.min'
]
define(deps, function(Ajax, Storage, template, UploadImage) {
	mui.plusReady(function() {
		var user = Storage.getObj('user');
		var self = plus.webview.currentWebview();
		$('#submit').on('tap', submitUser);
		$('#uploadImg').on('tap', uploadImg);
		$('#province').on('change', getCityList);
		$('#imgs').on('tap', '.userimg', removeImg);

		if (self.flag == 'update') {
			$('select').hide();
			var signupObj = self.signupObj;
			var ordernum = signupObj.ordernum;
			$('#orderName').val(signupObj.name);
			$('#mobile').val(signupObj.tel);
			$('#idNumer').val(signupObj.identificationNumber);
			$('#address').val(signupObj.address);
			var imageArray = signupObj.imagePath.split(',');
			for (var i = 0; i < imageArray.length; i++) {
				if (imageArray[i].trim() != '') {
					$('.imgs').prepend('<img class="userimg" src="' + self.serverPath + imageArray[i] + '" alt="' + imageArray[i] + '" />');
				}
			}
		} else {
			Ajax.send('AppServer/home/loadArea.do', {
				areaId: 1
			}, function(data) {
				if (data.success) {
					var html = template('select-province-tp', data);
					$('#province').html(html);
				}
			});
		}

		function getCityList() {
			var areaId = $('#province').find('option:selected').data('id');
			Ajax.send('AppServer/home/loadArea.do', {
				areaId: areaId
			}, function(data) {
				if (data.success) {
					var html = template('select-city-tp', data);
					$('#city').html(html);
				}
			});
		}

		function removeImg() {
			var t = $(this);
			plus.nativeUI.confirm("确认删除此图片?", function(r) {
				if (r.index == 0) {
					t.remove();
				}
			}, "壹块过");
		}

		function uploadImg() {
			var num = $('.imgs .userimg').length; //除去按钮
			if (num > 7) {
				plus.nativeUI.alert('最多上传8张!', function() {}, '壹块过');
			} else {
				UploadImage.galleryImg(Ajax.serverUrl + '/AppServer/home/uploadImage.do', 'memberImage', function(obj) {
					var imageName = obj.list.imageName;
					var imageServerPath = obj.list.imageServerPath;
					$('.imgs').prepend('<img class="userimg" alt="' + imageName + '" src="' + imageServerPath + '"/>');
				});
			}

		}

		function submitUser() {
			var imgNames = [];
			var $imgs = $('.imgs img').not('#uploadImg');
			$imgs.each(function() {
				imgNames.push($(this).attr('alt'));
			});
			var signupObj = {
				memberId: user.id,
				name: $('#orderName').val().trim(),
				tel: $('#mobile').val().trim(),
				identificationNumber: $('#idNumer').val().trim(),
				address: $('#province').val() + $('#city').val() + $('#address').val(),
				imagePath: imgNames.join(','),
				ordernum: ordernum
			};

			if (signupObj.name == '') {
				plus.nativeUI.alert('请输入名字!', function() {}, '壹块过');
			} else if (signupObj.tel == '') {
				plus.nativeUI.alert('请输入手机号!', function() {}, '壹块过');
			} else if (signupObj.identificationNumber == '') {
				plus.nativeUI.alert('请输入身份证号码!', function() {}, '壹块过');
			} else if (signupObj.address == '') {
				plus.nativeUI.alert('请输入地址!', function() {}, '壹块过');
			} else if (signupObj.imagePath == '') {
				plus.nativeUI.alert('请上传资料!', function() {}, '壹块过');
			} else if (!RegExps.Mobile.test(signupObj.tel)) {
				plus.nativeUI.alert('手机号格式不正确!', function() {}, '壹块过');
			} else if (!RegExps.IdCard.test(signupObj.identificationNumber)) {
				plus.nativeUI.alert('身份证号码不正确!', function() {}, '壹块过');
			} else {
				//代报名详情页面
				var dbmDetail = plus.webview.getWebviewById('find-detail-list-baoming-dbm-detail');
				//代报名详情[编辑]
				var orderEdit = plus.webview.getWebviewById('orderEdit');
				var target;
				if (self.flag == 'update') {
					target = orderEdit;
					signupObj.id = self.signupObj.id;
				} else {
					target = dbmDetail;
				}
				if (target) {
					mui.fire(target, 'addUser', signupObj);
				}
			}
		}

	});

});