var deps = ['H5PModules/Storage', 'H5PModules/Ajax', 'H5PModules/ValiLogin',
	'../libs/mui.min', '../libs/jquery.min'
];
define(deps, function(Storage, Ajax, ValiLogin) {
	mui.plusReady(function() {
		var user = Storage.getObj('user');
		var keys = Storage.getKeys();

		//获取版本
		var version = '';
		var CV = Storage.getObj('cloud-version-' + user.id);
		if (CV) {
			version = CV.version;
			$('#info-date').text(CV.updateTime.split(' ')[0]);
			$('#info-time').text(CV.updateTime.split(' ')[1]);
		}
		
		
		//计算数量,组装数据
		var records = Storage.getObj('ExamResults-' + user.id),recordsCount = 0;
		var favs = {},favsCount = 0; //{bankId:favList,...}
		var errors = {},errorsCount = 0; //{bankId:errors,...}
		for (var i = 0; i < keys.length; i++) {
			var arr = keys[i].split('-');
			//获取favs
			if (arr.length == 4 && arr[3] == 'favList' && arr[1] == user.id) {
				favs[arr[2]] = Storage.getObj(keys[i]);
				favsCount += Storage.getObj(keys[i]).length;
			}
			//获取errors
			if (arr.length == 4 && arr[3] == 'errors' && arr[1] == user.id) {
				errors[arr[2]] = Storage.getObj(keys[i]);
				errorsCount += Storage.getObj(keys[i]).length;
			}
		}
		if(records){
			recordsCount = records.length;
		}
		$('#records').text(recordsCount);
		$('#errors').text(errorsCount);
		$('#favs').text(favsCount);
		
			
		//点击同步
		$("#doSync").on('tap', doSync);


		/**
		 * 同步
		 */
		function doSync() {
			plus.nativeUI.showWaiting();
			
			var titles = {
				favs: favs,
				errors: errors,
				records: records
			};


			Ajax.send('AppServer/sugget/synchronousSugget.do', {
				memberId: user.id,
				version: version,
				titles: JSON.stringify(titles)
			}, function(data) {
				if(data.success){
					var cloudVersion = {
						version:data.list.version,
						updateTime:data.list.updateTime
					};
					Storage.setObj('cloud-version-' + user.id,cloudVersion);
					if(data.status == 355){
						//需要覆盖本地
						var url = data.serverPath + data.list.url;
						console.log(url)
						mui.ajax(url,{
							dataType:'text',
							type:'GET',
							success:function(jsonStr){
								sync2local(jsonStr,function(){
									plus.nativeUI.closeWaiting();
									mui.back();
								});
							},
							error:function(xhr,type,errorThrown){
								plus.nativeUI.closeWaiting();
//								plus.nativeUI.alert("通讯失败:HTTP状态码:"+xhr.status,function(){},'壹块过');
							}
						});
					}else{
						plus.nativeUI.closeWaiting();
						mui.back();
					}
				}

			});

		}
		
		
		//将服务端数据同步到本地
		function sync2local(jsonStr,callback){
			var keys = Storage.getKeys();
			var json;
			if(jsonStr == ""){
				json = {};
			}else{
				json = JSON.parse(jsonStr);
			}
			var favs = json.favs==undefined?[]:json.favs;
			var errors = json.errors==undefined?[]:json.errors;
			var records = json.records==undefined?[]:json.records;
			
			for(var i=0;i<keys.length;i++){
				if(keys[i].indexOf('-favList') != -1 || keys[i].indexOf('-errors') != -1){
					plus.storage.removeItem(keys[i]);
				}
			}
			
			for(key in favs){
				Storage.setObj('Bank-'+user.id+'-'+key+'-favList',favs[key]);
			}
			for(key in errors){
				Storage.setObj('Bank-'+user.id+'-'+key+'-errors',errors[key]);
			}
			
			Storage.setObj('ExamResults-' + user.id,records);
			callback();
		}


	});

});