var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5Modules/TemplateHelper','H5PModules/ValiLogin',
	'../libs/mui.min', '../libs/jquery.min', '../libs/underscore-1.8.2'
];
define(deps, function(Ajax, Storage, template, valiLogin) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var id = self.topsId;
		var user = Storage.getObj("user");

		var repPageNumber = 1;
		var wt = plus.nativeUI.showWaiting("获取中...");
		getDetail(function() {
			wt.setTitle("获取评论...");
			getReply(repPageNumber, function() {
				wt.close();
			});
		});

		$('#absCtn').on("tap", ".pinglun", function(){
			var self = this;
			if(valiLogin()){
				pinglun(self);
			}
		});
		$('#absCtn').on("tap", ".dianzan.canTap", function(){
			var self = this;
			if(valiLogin()){
				dianzan(self);
				var community = plus.webview.getWebviewById("community");
				if(community){
					mui.fire(community,"dorefresh");
				}
			}
		});
		$('#absCtn').on("tap", ".dianzan.cancel", function(){
			var self = this;
			if(valiLogin()){
				cancelDianzan(self);
				mui.fire(plus.webview.getWebviewById("community"),"dorefresh");
			}
		});

		window.addEventListener("addReply", function(e) {
			var data = e.detail;
			var html = template("commentsTP", {
				entity: [data.entity]
			});
			$("#comments").prepend(html);
			var pinglun = $(".pinglun span").text();
			var count = parseInt(pinglun);
			$(".pinglun span").text(count+1);
		});

		//分页
		var absCtn = $('#absCtn');
		var comments = $("#comments");
		var detail = $('#detail');
		var isEnd = false;
		absCtn.on('scroll', function() {
			if (absCtn.scrollTop() + absCtn.height() >= comments.height() + detail.height() && !isEnd) {　
				plus.nativeUI.showWaiting("加载更多评论...");
				isEnd = true;
				getReply(repPageNumber + 1, function(data) {
					plus.nativeUI.closeWaiting();
					if(data.entity.length == 0){
						mui.toast("没有评论了");
					}else{
						isEnd = false;
					}
					repPageNumber++;
				});
			}
		});

		//评论
		function pinglun() {
			var topsId = $(this).data("id");
			mui.openWindow({
				url: "../pages/p-community-reply.html",
				id: "community-reply",
				extras: {
					topsId: self.topsId
				}
			});
		}


		//点赞
		function dianzan(self) {
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/add.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i + 1);
					$t.attr("class","fr dianzan cancel");
					$t.find("img").attr("src","../img/community/iconfont-iconfontdianzan3.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}
		
		function cancelDianzan(self){
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/del.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i - 1);
					$t.attr("class","fr dianzan canTap");
					$t.find("img").attr("src","../img/community/iconfont-dianzan.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}

		//获取详情
		function getDetail(callback) {
			Ajax.send("bbs/tops/topDetails.do", {
				id: id,
				userId:user?user.id:""
			}, function(data) {
				if (data.ret_code == 0) {
					var html = template("detailTP", data);
					$("#detail").html(html);
					if (callback) {
						callback();
					}
				} else {
					console.log(JSON.stringify(data));
				}
			});

		}

		function getReply(pageNumber, callback) {
			Ajax.send("bbs/replys/seeReplysSQ.do", {
				pageSize: 10,
				pageNumber: pageNumber,
				topsId: id
			}, function(data) {
				if (data.ret_code == 0) {
					var html = template("commentsTP", data);
					$("#comments").append(html);
					if (callback) {
						callback(data);
					}
				} else {
					console.log(JSON.stringify(data));
				}
			});

		}

	});

});