var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5PModules/Upload-image',
	'../libs/mui.min', '../libs/jquery.min'
];
define(deps, function(Ajax, Storage, UploadImg) {
	mui.plusReady(function() {
		var user = Storage.getObj("user");

		$('#addImg').on('tap', uploadImg);
		$('#doPost').on('tap', doPost);
		$('#content').on("input",function(){
			var num = $(this).val().length;
			$("#textNum").text(num);
		});
		$('.imgs').on("tap", ".uploadImg", function() {
			var $t = (this);
			plus.nativeUI.confirm("是否删除图片?", function(r) {
				if (r.index == 0) {
					$t.remove();
				}
			}, "壹块过");
		});

		/**
		 * 发布
		 */
		function doPost() {
			var userId = user.id;
			var content = $("#content").val();
			if(content.length>200){
				plus.nativeUI.alert("内容不能超过200字", function() {}, '壹块过');
				return;
			}
			
			var imgs = [];
			var uploadImgs = $('.uploadImg');
			uploadImgs.each(function() {
				var name = $(this).data('name');
				imgs.push(name);
			});
			plus.nativeUI.showWaiting("发布中...");
			Ajax.send("bbs/tops/addTops.do", {
				content: content,
				sectionId: 2, //这个是板块id,因为现在做的社区,所有板块id是固定的.....每次传值为2就可以了
				imgs: imgs.join(","),
				userId: userId
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var community = plus.webview.getWebviewById("community");
					data.entity.replysCount = 0;
					data.entity.praiseCount = 0;
					mui.fire(community, "addTop", data);
					mui.back();
				} else {
					console.log(JSON.stringify(data));
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}

		function uploadImg() {
			if ($('.uploadImg').length > 5) {
				plus.nativeUI.alert('最多只能上传6张哦', function() {}, '壹块过');
			} else {
				UploadImg.galleryImg(Ajax.serverUrl + '/bbs/tops/imgUpload.do', 'image', function(obj, path) {
					if (obj.ret_code == 0) {
						$('.imgs').prepend('<img class="uploadImg" data-name="' + obj.imgName + '" src="' + path + '"/>');
					}
				});
			}

		}

	});
});