var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5Modules/TemplateHelper', 'H5PModules/ValiLogin',
	'../libs/mui.min', '../libs/jquery.min', '../libs/underscore-1.8.2'
];
define(deps, function(Ajax, Storage, template, valiLogin) {
	mui.plusReady(function() {
		window.addEventListener("dorefresh", function() {
			$("*").off("tap");
			READY2INIT();
		});
		READY2INIT();
	});
	
	
	function READY2INIT(){
		var user = Storage.getObj("user");
		var self = plus.webview.currentWebview();
		var pageNumber = 1;
		getList(pageNumber, true);

		$('#post').on("tap", function() {
			if (valiLogin()) {
				goPostPage();
			}
		});
		$('#absCtn').on("tap", ".l-ctn", goDetailPage);
		$('#absCtn').on("tap", ".pinglun", goDetailPage);
		$('#absCtn').on("tap", ".dianzan.canTap", function() {
			var self = this;
			if (valiLogin()) {
				dianzan(self);
			}
		});
		$('#absCtn').on("tap", ".dianzan.cancel", function(){
			var self = this;
			if(valiLogin()){
				cancelDianzan(self);
			}
		});

		//分页
		var absCtn = $('#absCtn');
		var listCtn = $("#listCtn");
		var pageTopHeight = 80;
		var isEnd = false;
		absCtn.on('scroll', function() {
			if (absCtn.scrollTop() + absCtn.height() == listCtn.height() + pageTopHeight && !isEnd) {　
				isEnd = true;
				getList(pageNumber + 1, false, function(data) {
					pageNumber++;
					if (data.entity.length == 0) {
						mui.toast("没有数据了");
					}else{
						isEnd = false;
					}
				});
			}
			if (absCtn.scrollTop() == 0) {
				pageNumber = 1;
				isEnd = false;
				$('#listCtn').empty();
				getList(pageNumber, true);
			}
		});
		absCtn.on("touchend", function() {
			if (absCtn.scrollTop() > 0 && absCtn.scrollTop() < pageTopHeight) {
				absCtn.animate({
					scrollTop: pageTopHeight
				}, 300);
			}
		});
		window.addEventListener("addTop", function(e) {
			var obj = e.detail;
			var html = template("list-tp", {
				imgMaxServer: obj.imgMaxServer,
				imgMinServer: obj.imgMinServer,
				entity: [obj.entity],
				headImgServerPath: obj.headImgServerPath
			});
			$('#listCtn').prepend(html);
			absCtn.animate({
				scrollTop: pageTopHeight
			}, 300);
		});

		//点赞
		function dianzan(self) {
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/add.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i + 1);
					$t.attr("class","fr dianzan cancel");
					$t.find("img").attr("src","../img/community/iconfont-iconfontdianzan3.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}
		
		function cancelDianzan(self){
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/del.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i - 1);
					$t.attr("class","fr dianzan canTap");
					$t.find("img").attr("src","../img/community/iconfont-dianzan.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}

		//评论
		function goDetailPage() {
			var topsId = $(this).data("id");
			mui.openWindow({
				url: "../pages/p-community-detail.html",
				id: "community-detail",
				extras: {
					topsId: topsId
				}
			});
		}

		function goPostPage() {
			mui.openWindow({
				url: "../pages/p-community-post.html",
				id: "community-post",
				extras: {

				}
			});
		}
		/**
		 * 获取数据
		 */
		function getList(pageNumber, goTop, callback) {
			plus.nativeUI.showWaiting("加载中...");
			Ajax.send("bbs/tops/topsList.do", {
				userId:user?user.id:"",
				pageNumber: pageNumber,
				pageSize: 10,
				sectionId: 2 //这个是板块id,因为现在做的社区,所有板块id是固定的.....每次传值为2就可以了
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var html = template("list-tp", data);
					$('#listCtn').append(html);
					if (goTop) {
						absCtn.animate({
							scrollTop: pageTopHeight
						}, 300);
					}
					if (callback) {
						callback(data);
					}
				} else {
					console.log(JSON.stringify(data));
				}
			});

		}

		//ready end
	
	}

});