var deps = ['H5PModules/Storage', '../libs/template', 'H5PModules/ValiLogin', 'Alert',
	'../libs/mui.min', '../libs/jquery.min', '../libs/GSAP1.18.0/TweenMax.min'
];
define(deps, function(Storage, template, valiLogin, Alert) {
	mui.plusReady(function(){
		window.addEventListener("dorefresh", function() {
			$("*").off("tap").off("click");
			READY2INIT();
		});
		READY2INIT();
	});
	
	function READY2INIT(){
		var user = Storage.getObj('user');
		var bankId = plus.storage.getItem('NowBank-' + user.id);
		var subjects = Storage.getObj('Bank-' + user.id + '-' + bankId + '-subjects');
		if (subjects == null) {
			plus.nativeUI.alert('还未选择题库!', function() {}, "壹块过");
		}

		if (subjects != null) {
			var html = template('c-nav-tp', subjects);
			$('#c-nav-ctn').html(html);
			initNav();
		}
		events();

		//顶部的科目列表
		function initNav() {
			var totalWidth = 0;
			$('.c-nav table td').each(function() {
				totalWidth += $(this).width()+5;
			});
			$('.c-nav>.scrollX').width(totalWidth);
		}

		function events() {
			//切换提包
			//我的题库
			$('#changeBank').on('tap', function() {
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myQBank.html',
						id: 'myQBank'
					});
				}
			});


			//顶部切换
			$('#c-nav-ctn').on('tap', '.fl', function() {
				plus.nativeUI.showWaiting('切换中...');
				$('#c-nav-ctn .fl').removeClass('active');
				$(this).addClass('active');
				setTimeout(function() {
					plus.nativeUI.closeWaiting();
				}, 300);
			});

			//动画特效
//			$('.s3grid .span3').on('tap', function() {
//				var btn = $(this).find('.btn');
//				btn.addClass('swing');
//				setTimeout(function() {
//					btn.removeClass('swing');
//				}, 1000);
//			});
			$('#goSpecialPraPage').on('tap', function() {
				if (valiLogin()) {
					var $active = $('#c-nav-ctn').find('.active');
					mui.openWindow({
						url: '../pages/p-specialPractice.html',
						id: 'specialPractice',
						extras: {
							activeId: $active.data('id')
						}
					});
				}
			});
			//模拟练习
			$('#goPracticeTest').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-startTest.html',
						id: 'startTest',
						extras: {
							user: Storage.getObj('user'),
							activeId: $active.data('id')
						}
					});
				}
			});
			//错题练习
			$('#goErrorQPage,#goMyErrorList').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-questions-pra.html',
						id: 'questions-pra',
						extras: {
							flag: 'errorQ',
							activeId : $active.data('id')
						}
					});
				}
			});
			
			//随机练习
			$('#goRandomQPage').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-questions-pra.html',
						id: 'questions-pra',
						extras: {
							flag: 'random',
							activeId : $active.data('id')
						}
					});
				}
			});
			//顺序练习
			$('#goNormalQPage').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-questions-pra.html',
						id: 'questions-pra',
						extras: {
							flag: 'line',
							activeId : $active.data('id')
						}
					});
				}
			});
			
			
			//难题
			$('#goHardPage').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-questions-pra.html',
						id: 'questions-pra',
						extras: {
							flag: 'hard',
							activeId : $active.data('id')
						}
					});
				}
			});
			
			//收藏的题
			$('#goMyFavList').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-questions-pra.html',
						id: 'questions-pra',
						extras: {
							flag: 'fav',
							activeId : $active.data('id')
						}
					});
				}
			});
			
			
			$('#goTopPage').on('tap', function() {
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-examList.html',
						id: 'examList',
						extras: {
							activeId : $active.data('id')
						}
					});
				}
			});
			
			//考试结果
			$("#goMyExamResultsPage").on('tap', function() {
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myExamResults.html',
						id: 'myExamResults'
					});
				}
			});
			$("#goChartPage").on('tap', function() {
//				plus.nativeUI.alert('此功能仍在开发中!', function() {}, "壹块过");
//				return;
				var $active = $('#c-nav-ctn').find('.active');
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-examAnalyze.html',
						id: 'examAnalyze',
						extras: {
							activeId: $active.data('id')
						}
					});
				}
			});
			$('#goCloud').on('tap', function() {
				//				plus.nativeUI.alert('此功能仍在开发中!', function() {}, "壹块过");
				//				return;
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-cloud.html',
						id: 'cloud'
					});
				}
			});
		}

	
	}
});