/**
 * 题库下载模块
 * 依赖:['H5PModules/Download', 'H5PModules/FileReader', 'H5PModules/Storage']
 */
define(['H5PModules/Download', 'H5PModules/FileReader', 'H5PModules/Storage'], function(Download, FileReader, Storage) {
	var exports = {};
	exports.do = function(url, packageId, callback,statechange) {
		plus.io.resolveLocalFileSystemURL("_downloads/", function(entry) {
			if (entry.isDirectory) {
				entry.removeRecursively(function() {
					start();
					console.log('remove success');
				}, function() {
					console.log('remove error');
				});
			}
		}, function(e) {
			alert("Resolve file URL failed: " + e.message);
		});

		function start() {
			Download.start(url, function(d) {
				var user = Storage.getObj('user');
				var d_url = d.filename;
				//下载完成
				var wt = plus.nativeUI.showWaiting('正在解压缩...\n可能花费较长时间,请耐心等待.',{back:'none'});
				plus.zip.decompress(d_url, '_doc/QuestionData/temp/', function() {
					console.log("Decompress success!");
					//读取titles
					var __readFunName;
					if(mui.os.ios){
						__readFunName = "readText";
					}else{
						__readFunName = "readText_ad_fixed";
					}
					FileReader[__readFunName]('_doc/QuestionData/temp/titles.json', function(text) {
						text = Storage.replaceSpec(text);
						plus.storage.setItem('Bank-' + user.id + '-' + packageId + '-titles', text);
						console.log("Read titles success!");
						//读取subjects
						FileReader[__readFunName]('_doc/QuestionData/temp/subjects.json', function(text) {
							text = Storage.replaceSpec(text);
							plus.storage.setItem('Bank-' + user.id + '-' + packageId + '-subjects', text);
							//所有读取完成,执行回调
							console.log("Read subjects success!");
							wt.close();
							callback();
						}, function(e) {
							console.log("reader error!");
						});
					}, function(e) {
						console.log("reader error!");
					});
				}, function(error) {
					console.log("Compress error!" + JSON.stringify(error));
				});
			},function(download){
				statechange(download);
			});


		}


	};

	return exports;
});