var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5Modules/TemplateHelper', 'H5PModules/ValiLogin',
	'../libs/mui.min', '../libs/jquery.min', '../libs/RegExps',
	'../libs/underscore-1.8.2'
];
define(deps, function(Ajax, Storage, template,valiLogin) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var activeId = self.activeId;
		var user = Storage.getObj("user");
		var bankId = plus.storage.getItem('NowBank-' + user.id);
		
		//科目信息
		var subjects = Storage.getObj('Bank-' + user.id + '-' + bankId + '-subjects');
		
		//科目信息
		subjects = subjects.subjects;
		
		//当前科目
		var subject = _.find(subjects,function(obj){
			return obj.id == activeId;
		});
		
		//考试ID
		var examId = subject.examId;
		
		require(['../libs/jquery.circliful.min'], function () {
			getData(examId);
		});

		function getData(examId) {
			plus.nativeUI.showWaiting("获取中...");
			Ajax.send("AppServer/memberExam/ExamStatistics.do", {
				memberId: user.id,
				examId: examId
			}, function(data) {
				plus.nativeUI.closeWaiting();
				console.info(JSON.stringify(data));
				if (data.success) {
					var examObj = data.list;
					var html = template("examAnalyze-tp", {examObj:examObj});
					$('#absCtn').html(html);
					$('#surpassPer').text(parseFloat(examObj.surpassPeopleNum/examObj.examPeopleNum*100).toFixed(2)+'%');
					//设置百分比
					$('#myStat').attr("data-text",parseFloat(examObj.passCount/examObj.count*100).toFixed(2)+'%');
					$('#myStat').attr("data-percent",parseFloat(examObj.passCount/examObj.count*100).toFixed(2));
					//初始化圆环图
					$('#myStat').circliful({animationStep: 10.0});
					//$('.circle-text').text(parseFloat(examObj.passCount/examObj.count*100).toFixed(2)+'%');
					$('.circle-info').css({"color":"#fff"});
				}else{
					var html = template("examAnalyze-tp", {examObj:{
						avgScore:0,
						maxScore:0,
						minScore:0,
						count:0,
						passCount:0
					}});
					$('#absCtn').html(html);
					$('#surpassPer').text('0.00%');
					//设置百分比
					$('#myStat').attr("data-text",'0.00%');
					$('#myStat').attr("data-percent","0.00%");
					//初始化圆环图
					$('#myStat').circliful({animationStep: 10.0});
					$('.circle-info').css({"color":"#fff"});
				}
			});
		}

		//模拟练习
		$('#absCtn').on('tap','#reTry', function() {
			if (valiLogin()) {
				mui.openWindow({
					url: '../pages/p-startTest.html',
					id: 'startTest',
					extras: {
						user: Storage.getObj('user'),
						activeId: activeId
					}
				});
			}
		});
	});
});