var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5Modules/TemplateHelper', 'H5PModules/Pay',
	'../libs/mui.min', '../libs/jquery.min', '../libs/underscore-1.8.2', '../libs/swiper/js/swiper.min'
];
define(deps, function(Ajax, Storage, template, Pay) {
	mui.plusReady(function() {
		plus.nativeUI.showWaiting('加载中...');
		var self = plus.webview.currentWebview();
		var user = Storage.getObj('user');
		var serverData;
		var tp = {
			userList: template.compile($('#userList-tp').html())
		};
		var postObj = {
			order: {},
			signup: []
		};

		//查询信息
		Ajax.send('AppServer/organization/findOrgTrainByid.do', self.opts, function(data) {
			getComments(1);
			serverData = data;
			if (data.success) {
				var html = template('list-tp', data);
				var promotion = '' + data.list.promotionprice;
				var ppZhengshu = '' + promotion.substring(0, promotion.indexOf('.'));
				var ppXiaoshu = '' + promotion.substr(promotion.indexOf('.') + 1, 2);
				var signupEndtime = data.list.signupEndtime.substring(0, data.list.signupEndtime.indexOf(' '));

				$('#list-ctn').html(html);
				$('#ppZhengshu').html(ppZhengshu);
				$('#ppXiaoshu').html(ppXiaoshu);
				$('#signup_endtime').html(signupEndtime);

				//轮播
				$('#title').text(data.list.name);

				var swiper = new Swiper('.swiper-container', {
					pagination: '.swiper-pagination',
					autoplay: 2000
				});
				$('#info').on('tap', showInfo);
			} else {
				plus.nativeUI.alert('获取失败!', function() {
					mui.back();
				}, '壹块过');
			}
			plus.nativeUI.closeWaiting();
		});


		$('#goPay').on('tap', submitOrder);
		$('#list-ctn').on('tap', '#addOrder', goAddOrderUserPage);
		$('#list-ctn').on('tap', '.removeUser', removeUser);




		//监听增加用户事件
		window.addEventListener('addUser', function(signupObj) {
			postObj.signup.push(signupObj.detail);
			var html = tp.userList(postObj);
			$('#userList-ctn').html(html);
			plus.webview.getWebviewById('baoming-addUser').close();
			var n = postObj.signup.length;
			var price_sum = serverData.list.promotionprice * n;

			$('#sumPrice').text('订单总额￥' + price_sum);
		});
		
		function getComments(pageNumber,callback) {
			Ajax.send("bbs/replys/seeReplys.do", {
				pageSize: 30,
				pageNumber: pageNumber,
				sectionId: 5, //板块ID,固定
				stId: self.opts.id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var html = template("comment-tp", data);
					$("#comment ul").append(html);
					if(pageNumber == 1 && data.total == 0){
						$("#comment").hide();
						$("#detail-ctn").off("touchend");
					}
				}
				if(callback){
					callback(data);
				}
			});
		}

		function removeUser() {
			var identificationNumber = $(this).data('idn');
			postObj.signup = _.filter(postObj.signup, function(obj) {
				return obj.identificationNumber != identificationNumber;
			});
			var html = tp.userList(postObj);
			$('#userList-ctn').html(html);
			var n = postObj.signup.length;
			var price_sum = serverData.list.promotionprice * n;
			$('#sumPrice').text('订单总额￥' + price_sum);
		}

		/**
		 * 添加报名人页面
		 */
		function goAddOrderUserPage() {
			mui.openWindow({
				url: '../pages/p-baoming-addUser.html',
				id: 'baoming-addUser'
			});
		}
		/**
		 * 提交订单
		 */

		function submitOrder() {
			var order = {
				productId: serverData.list.id,
				productName: serverData.list.certName,
				productType: 1,
				price: serverData.list.promotionprice,
				tradeCount: postObj.signup.length,
				memberId: user.id,
				orgId: serverData.list.orgId
			};

			if (order.tradeCount == 0) {
				plus.nativeUI.alert('请添加报名人!', function() {}, '壹块过');
				return;
			}

			//去支付选择页面
			mui.openWindow({
				url: '../pages/p-payChoose.html',
				id: 'payChoose',
				extras: {
					productName: order.productName,
					price: order.price * order.tradeCount,
					order: order,
					signup: postObj.signup,
					noCallback:true
				}
			});

		}

		function showInfo() {
			if ($('#info').hasClass('mui-ellipsis')) {
				$('#info').removeClass('mui-ellipsis');
			} else {
				$('#info').addClass('mui-ellipsis');
			}
		}
	});
});