var deps = ['H5PModules/Ajax', 'H5PModules/Storage', '../libs/template','H5PModules/ValiLogin',
	'../libs/photoswipe/photoswipe.js', '../libs/photoswipe/photoswipe-ui-default.js',
	'../libs/mui.min', '../libs/jquery.min', '../libs/underscore-1.8.2', '../libs/swiper/js/swiper.min'
];

define(deps, function(Ajax, Storage, template,valiLogin, PhotoSwipe, PhotoSwipeUI_Default) {
	mui.plusReady(function() {

		plus.nativeUI.showWaiting('获取数据...');

		var self = plus.webview.currentWebview();
		var orgId = self.orgId; //机构id
		var user = Storage.getObj('user');
		var itemImg;

		//评分模版自定义
		template.helper('$num2star', function(n) {
			var num = parseInt(n);
			var result = '';
			for (var i = 0; i < num; i++) {
				result += '<img height="18" src="../img/common/blueStar.png" />';
			}
			if (num < 5) {
				var left = 5 - num;
				for (var i = 0; i < left; i++) {
					result += '<img height="18" src="../img/common/blueStar2.png" />';
				}
			}
			return result;
		});
		
		//是否关注了
		isFollowed();
		// 机构基本信息
		findOrgInfo();


		function findOrgInfo() {
			// 机构基本信息
			plus.nativeUI.showWaiting();
			Ajax.send('AppServer/organization/findOrgInfo.do', {
				orgId: orgId
			}, function(data) {
				if (data.success && data.list != null) {
					// 机构基本信息绑定
					var html = template('org-baseInfo-tmpl', data);
					$('.baseInfo').html(html);
					itemImg = [];
					// 如果没有图片就不点击事件了
					if (data.list == null || data.list.resLinkList == null) {
						return;
					}
					for (var i = 0; i < data.list.resLinkList.length; i++) {
						itemImg[i] = {};
						itemImg[i].src = data.serverPath + data.list.resLinkList[i].imagePath;
						itemImg[i].w = 600;
						itemImg[i].h = 400;
					}
				}
				findActivityList();
			});


		}

		function findActivityList() {
			// 机构课程列表
			Ajax.send('AppServer/activity/findAllActivity.do', {
				orgId: orgId
			}, function(data) {
				if (data.success && data.list != null) {
					var html = template('org-activityInfo-tmpl', data);
					$('#activityInfo').html(html);

					//轮播
					var swiper = new Swiper('.swiper-container', {
						pagination: '.swiper-pagination',
						autoplay: 2000,
					});
				}
				findOrgTrain();
				dlPackageList();
			});


		}

		function findOrgTrain() {
			// 机构课程列表
			Ajax.send('AppServer/orgtrain/findOrgTrain.do', {
				orgId: orgId
			}, function(data) {
				if (data.success) {
					if (data.list == null || data.list.length == 0) {
						$('#trainInfoTitle').html('');
					}else if (data.list.length != 0) {
						var html = template('org-traininfo-tmpl', data);
						$('#list-traininfo').html(html);

					} else {
						$('#trainInfoTitle').html('暂无课程');
					}
					
				}
				bindEvent();
			});

		}
		
		function dlPackageList(){
			Ajax.send("AppServer/tpackage/dlPackageList.do",{
				orgId: orgId
			},function(data){
				if (data.success) {
					var html = template('org-package-tmpl', data);
					$('#list-package').html(html);
				} else {
					$('#list-package').html('');
				}
			});
		}




		//绑定描述事件
		function bindEvent() {
			plus.nativeUI.closeWaiting();
			$('#absCtn').on('tap', '.org-package-item', function() {
				if (valiLogin()) {
					var opts = {
						id: $(this).data('id')
					};
					mui.openWindow({
						url: '../pages/p-bank-detail.html',
						id: 'bank-detail',
						extras: {
							opts: opts
						}
					});
				}
			});
			
			$('.swiper-slide img').on('tap', function() {
				var activityId = $(this).attr('_activityId');
				mui.openWindow({
					url: '../pages/p-activityDetail.html',
					id: 'activityDetail',
					extras: {
						activityId: activityId
					}
				});
			});
			$('#photoswiper').on('tap', function() {
				// 防止苹果点透事件
				plus.nativeUI.showWaiting();
				setTimeout(function() {
					var pswpElement = document.querySelectorAll('.pswp')[0];
					var options = {
						index: 0 // start at first slide
					};
					var gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, itemImg, options);
					gallery.init();
					plus.nativeUI.closeWaiting();
				}, 300);
			});
			$('#toDescDetail').on('tap', function() {
				var descDetail = $('#descDetail').html();
				mui.openWindow({
					url: '../pages/p-find-detail-list-jigou-detail-desc.html',
					id: 'find-detail-list-jigou-detail-desc',
					extras: {
						descDetail: descDetail
					}
				});
			});
			//关注事件
			$('#phone').on('tap', function() {
				window.location.href = "tel:" + $('#phoneIn').html();
			});
			//关注事件
			$('#doFav').on('tap', function() {
				var $t = $(this);
				if ($t.hasClass('active')) {
					cancelFollowed();
				} else {
					doFollow();
				}
			});
			$("#absCtn").on("tap",".bm-list",function(){
				var id = $(this).data("id");
				mui.openWindow({
					url: '../pages/p-find-detail-list-jigou-detail-info.html',
					id: "find-detail-list-jigou-detail-info",
					extras: {
						pxId:id
					}
				});
			});
		}


		function isFollowed() {
			Ajax.send('AppServer/member/isFollowed.do', {
				memberId: user.id,
				orgId: orgId,
				careType: 1
			}, function(data) {
				if (data.status == 104) {
					$('#doFav').addClass('active');
				}
			});
		}

		function doFollow() {
			plus.nativeUI.showWaiting();
			Ajax.send('AppServer/member/doFollow.do', {
				memberId: user.id,
				orgId: orgId,
				careType: 1
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.status == 104) {
					$('#doFav').addClass('active');
				}
			});
		}

		function cancelFollowed() {
			plus.nativeUI.showWaiting();
			Ajax.send('AppServer/member/cancelFollowed.do', {
				memberId: user.id,
				orgId: orgId,
				careType: 1
			}, function(data) {
				plus.nativeUI.closeWaiting();
				$('#doFav').removeClass('active');
			});
		}

		plus.nativeUI.closeWaiting();
	});



});