var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'RangeBar',
	'../libs/template', '../libs/mui.min', '../libs/jquery.min',
	'../libs/underscore-1.8.2'
];
define(deps, function(Ajax, Storage, RangeBar, template) {
	mui.plusReady(function() {
		var majorCache; //用于搜索
		var serverPath;
		getCertifications();
		events();

		function getCertifications() {
			plus.nativeUI.showWaiting('加载数据...');
			Ajax.send('AppServer/jobCert/findCertHot.do', {}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.success) {
					serverPath = data.serverPath;
					var html_hot = template('cerHotList-tp', data);
					$('#f-hotList').html(html_hot);
				} else {
					plus.nativeUI.alert(data.msg, function() {}, "壹块过");
				}
			});

			Ajax.send('AppServer/jobCert/findMajor.do', {}, function(data) {
				if (data.success) {
					majorCache = data;
					var html = template('cerList-tp', data);
					$('#f-list').html(html);
				} else {
					plus.nativeUI.alert(data.msg, function() {}, "壹块过");
				}
				plus.nativeUI.closeWaiting();
			});

		}


		function events() {
			$("#showSearchBar").on("tap",function(){
				$("#searchBar").toggle();
			})
			//[点击]专业列表
			$('#f-list').on('tap', 'li', function() {
				var opts = {
					majorId: $(this).data('id'),
					areaName: getAddress().province
				};
				mui.openWindow({
					url: 'p-find-detail-list.html',
					id: 'find-detail-list',
					extras: {
						opts: opts
					}
				});
			});
			//[点击]热门
			$('#f-hotList').on('tap', '.span3', function() {
				var opts = {
					majorId: $(this).data('id'),
					areaName: getAddress().province
				};
				mui.openWindow({
					url: 'p-find-detail-list.html',
					id: 'find-detail-list',
					extras: {
						opts: opts
					}
				});
			});

			$("#searchText").on("input",function(){
				doFilterSearch();
			});
		}

		function doFilterSearch() {
			var keyword = $('#searchText').val();
			var obj = JSON.parse(JSON.stringify(majorCache));
			var isEmpty = true;
			if (keyword.trim() == '') {
				isEmpty = false;
			} else {
				for (var i = 0; i < majorCache.list.length; i++) {
					var _list0 = majorCache.list[i].list;
					obj.list[i].list = [];
					for (var j = 0; j < _list0.length; j++) {
						var name = _list0[j].name;
						if (name.indexOf(keyword) != -1) {
							obj.list[i].list.push(_list0[j]);
							isEmpty = false;
						}
					}
				}
			}
			if (!isEmpty) {
				//清楚空字母
				var list = _.filter(obj.list, function(o) {
					return o.list.length > 0;
				});
				console.log(JSON.stringify(list))
				var html = template('cerList-tp', {
					serverPath: serverPath,
					list: list
				});
				$('#f-list').html(html);
			} else {
//				plus.nativeUI.alert('无匹配结果!', function() {}, '壹块过');
			}
//			$('#searchText').blur();




		}

		//获取定位的地址
		function getAddress() {
			var address;
			var location = Storage.getObj('location');
			if (location == null) {
				console.log('定位失败!');
				address = {
					province: ''
				};
			} else {
				address = location.address;
			}
			return address;
		}

	});

});