/**
 * 用于模板格式化
 */
define(['../../libs/template', 'H5PModules/Ajax', '../../libs/moment.min'], function(template, Ajax, moment) {
	template.helper('$abcd', function(content) {
		var table = ['A', 'B', 'C', 'D', 'E', 'F', 'G'];
		return table[content - 1];
	});

	template.helper('$getColors', function(content) {
		var colors = ['#5acb5a', '#bc7cfc', '#faa912', '#fc7878', '#25c8da', '#18b4ed'];
		var i = content % 6;
		return colors[i];
	});

	//模版自定义
	template.helper('$num2star', function(n) {
		var num = parseInt(n);
		var result = '';
		for (var i = 0; i < num; i++) {
			result += '<img height="18" src="../img/common/blueStar.png" />';
		}
		if (num < 5) {
			var left = 5 - num;
			for (var i = 0; i < left; i++) {
				result += '<img height="18" src="../img/common/blueStar2.png" />';
			}
		}
		return result;
	});
	template.helper('$formatPrice', function(n) {
		var result = '';
		if (n == 0 || n == '') {
			result = '免费';
		} else {
			result = '￥' + n;
		}
		return result;
	});

	template.helper('$filterURL', function(url) {
		var result;
		if (!url) {
			result = "";
		} else if (url.toLowerCase().indexOf("http://") == -1) {
			result = Ajax.serverUrl + url;
		} else {
			result = url;
		}
		return result;
	});

	template.helper('$formatTimeBySec', function(sec) {
		var result;
		var mObj = moment.duration(sec * 1000);
		console.log(sec)
		var h = mObj.hours();
		var m = mObj.minutes();
		var s = mObj.seconds();
		result = h + "时" + m + "分" + s + "秒";
		return result;
	});

	template.helper('$formatState', function(s, isPackage) {
		var r;
		if (s == 1) {
			r = '待付款';
		} else if (s == 2) {
			if(isPackage){
				r = '已付款';
			}else{
				r = '审核中';
			}
		} else if (s == 3) {
			r = '审核通过';
		} else if (s == 4) {
			r = '审核失败';
		} else if (s == 5) {
			r = "申请退款中";
		} else if (s == 6) {
			r = "退款成功";
		} else if (s == 7) {
			r = "拒绝退款";
		}
		return r;
	});

	template.helper('$formatProductType', function(s) {
		//1、代报名  2、题包  3、线下培训
		var r;
		if (s == 1) {
			r = '代报名';
		} else if (s == 2) {
			r = '题包';
		} else if (s == 3) {
			r = '线下培训';
		}
		return r;
	});

	template.helper('$formatSignupType', function(s) {
		//1、代报名  2、题包  3、线下培训
		var r;
		if (s == 1) {
			r = '未审核';
		} else if (s == 2) {
			r = '审核通过';
		} else if (s == 3) {
			r = '审核失败';
		} else {
			r = "未知";
		}
		return r;
	});
	
	//我的证书状态
	template.helper('$formatMemberCert', function(s) {
		//1、未审核  2、审核通过  3、审核失败
		var r;
		if (s == 1) {
			r = '未审核';
		} else if (s == 2) {
			r = '审核通过';
		} else if (s == 3) {
			r = '审核失败';
		} else if (s == 4) {
			r = '已晒证';
		} else {
			r = "未知";
		}
		return r;
	});

	return template;
});