var deps = ['H5PModules/Storage', 'H5PModules/Download', 'H5PModules/Ajax',
	'../libs/fastclick', 'H5PModules/AuthLogin', 'H5PModules/CloseAll',
	'../libs/jquery.min', '../libs/mui.min', '../libs/moment.min',
	'../libs/underscore-1.8.2'
];
require(deps, function(Storage, Download, Ajax, FastClick, AuthLogin, closeAll) {
	FastClick.attach(document.body);
	mui.plusReady(function() {
		plus.nativeUI.showWaiting('加载中...');
		plus.navigator.setLogs(true);
		plus.screen.lockOrientation("portrait-primary");
		plus.storage.setItem('devModel', 'true');
		AuthLogin.init();
		//获取推送标志
		getPushInfo();


		// 监听在线消息事件
		plus.push.addEventListener("receive", function(msg) {}, false);


		//		WebSocket
		openSw();
		window.addEventListener('openSw', function() {
			openSw();
		});

		function openSw() {
			var itv;
			var user = Storage.getObj('user');
			if (user == null) {
				return;
			}

			if (!!window.WebSocket) {
				//支持WS
				var ws = new WebSocket(Ajax.socketUrl + user.id);
				ws.onopen = function() {
					if (user != null) {
						ws.send(JSON.stringify({
							id: user.id
						}));
					}
					itv = setInterval(function() {
						//实时监测用户,防止注销后的内存遗留
						user = Storage.getObj('user');
						if (user != null) {
							ws.send(JSON.stringify({
								id: user.id
							}));
						}
					}, 10000);
				};
				ws.onmessage = function(evt) {
					console.log(evt.data);
					autoLogout(evt.data, itv);
				};
				ws.onclose = function(evt) {
					console.log("WebSocketClosed!");
					clearInterval(itv);
				};
				ws.onerror = function(evt) {
					console.log("WebSocketError!");
				};
			} else {
				//不支持WS
				if (user != null) {
					poll();
				}
				itv = setInterval(function() {
					//实时监测用户,防止注销后的内存遗留
					user = Storage.getObj('user');
					if (user != null) {
						poll();
					}
				}, 10000);

				function poll() {
					mui.ajax(Ajax.pollUrl + 'ajax/login', {
						data: {
							id: user.id,
							operateType: "poll",
							token: plus.device.uuid
						},
						dataType: 'json',
						type: 'POST',
						timeout: 20000,
						success: function(data) {
							autoLogout(JSON.stringify(data), itv);
						},
						error: function(xhr, type, errorThrown) {
							if (xhr.status == 0) {
								mui.toast('网络不通,请检查网络设置.');
							} else if (xhr.status == 408) {
								mui.toast('请求超时,请检查网络设置.');
							} else {
								plus.nativeUI.alert("通讯失败:HTTP状态码:" + xhr.status, function() {}, '壹块过');
							}
							plus.nativeUI.closeWaiting();
							clearInterval(itv);
						}
					});


				}




			}

		}

		function autoLogout(data, itv) {
			var obj = JSON.parse(data);
			var user = Storage.getObj('user');
			if (!user) {
				return;
			}
			var userCenter = plus.webview.getWebviewById("userCenter");
			if (!obj.token) {
				AuthLogin.logoutAll();
				plus.storage.removeItem('user');
				if (userCenter) {
					mui.fire(userCenter,"dorefresh");
				}
				plus.nativeUI.alert('登录过期!需要重新登录!', function(e) {
					mui.openWindow({
						url: 'login.html',
						id: 'login',
						extras: {
							closeAll: true
						}
					});
				}, "壹块过 ", "重新登录");
			} else if (obj.token != plus.device.uuid && obj.id == user.id) {
				AuthLogin.logoutAll();
				plus.storage.removeItem('user');
				clearInterval(itv);
				if (userCenter) {
					mui.fire(userCenter,"dorefresh");
				}
				plus.nativeUI.confirm('检测到账户在其他设备登录,已自动注销!', function(e) {
					if (e.index == 0) {
						mui.openWindow({
							url: 'login.html',
							id: 'login',
							extras: {
								closeAll: true
							}
						});
					} else {
						mui.openWindow({
							url: 'login.html',
							id: 'login',
							extras: {
								closeAll: true,
								changePsw: true
							}
						});
					}
				}, "壹块过 ", ["重新登录", "修改密码"]);
			}

		}


		var self = plus.webview.currentWebview();
		var $navs = $('.pass-nav-b .span4');

		var vStyle = {
			top: 0,
			bottom: '50px',
		};
		var subpages = [{
			url: './pages/p-main.html',
			id: 'main',
			styles: vStyle
		}, {
			url: './pages/p-criticism.html',
			id: 'criticism',
			styles: vStyle
		}, {
			url: './pages/p-find.html',
			id: 'find',
			styles: vStyle
		}, {
			url: './pages/p-community.html',
			id: 'community',
			styles: vStyle
		}, {
			url: './pages/p-userCenter.html',
			id: 'userCenter',
			styles: vStyle
		}];

		var first = plus.webview.create(subpages[0].url, subpages[0].id, subpages[0].styles);
		self.append(first);


		pageRender();

		plus.nativeUI.closeWaiting();

		//[监听]转到考证页面
		window.addEventListener('change2criticism', function() {
			$navs.removeClass('active');
			$navs.eq(1).addClass('active');
			showOneWV('criticism');
		});
		window.addEventListener('change2find', function() {
			$navs.removeClass('active');
			$navs.eq(2).addClass('active');
			showOneWV('find');
		});


		function pageRender() {
			$navs.on('click', function() {
				var user = Storage.getObj('user');
				var link = $(this).data('link');
				//关闭用户中心的日历
				var userCenter = plus.webview.getWebviewById('userCenter');
				if (!!userCenter) {
					mui.fire(userCenter, 'closeCalendar');
				}
				if (link == 'criticism' && user == null) {
					plus.nativeUI.confirm("需要先登录", function(r) {
						if (r.index == 0) {
							mui.openWindow({
								url: 'login.html',
								id: 'login'
							});
						}
					}, "壹块过");
				} else if (link == 'criticism' && Storage.getObj('NowBank-' + user.id) == null) {
					plus.nativeUI.confirm("需要先选择题库", function(r) {
						if (r.index == 0) {
							Ajax.send('AppServer/tpackage/findPayPackage.do', {
								memberId: user.id
							}, function(data) {
								if (data.success) {
									var list = data.list;
									if (list.length == 0) {
										$navs.removeClass('active');
										$navs.eq(2).addClass('active');
										showOneWV('find');
									} else {
										mui.openWindow({
											url: 'pages/p-myQBank.html',
											id: 'myQBank'
										});
									}
								}
							});



						}



					}, "壹块过");
				} else {
					$navs.removeClass('active');
					$(this).addClass('active');
					showOneWV(link);
				}
			});



		}

		/**
		 * 显示界面
		 */
		function showOneWV(link) {
			plus.nativeUI.showWaiting('加载中...');
			var v = plus.webview.getWebviewById(link);
			if (v) {
				v.show();
			} else {
				var o = _.find(subpages, function(obj) {
					return obj.id == link;
				});
				v = plus.webview.create(o.url, o.id, o.styles);
				self.append(v);
			}

			plus.nativeUI.closeWaiting();
		}

		/**
		 * 获取本地推送标识信息
		 */
		function getPushInfo() {
			var info = plus.push.getClientInfo();
			plus.storage.setItem('clientid', info.clientid);
			//			outSet("获取客户端推送标识信息：");
			//			outLine("token: " + info.token);
			//			outLine("clientid: " + info.clientid);
			//			outLine("appid: " + info.appid);
			//			outLine("appkey: " + info.appkey);
		}

		//返回自定义
		mui.back = function() {
			if (window.showMenu) {
				main_menu.closeMenu();
			} else {
				plus.nativeUI.confirm("确认退出?", function(r) {
					if (r.index == 0) {
						plus.runtime.quit();
					}
				}, "壹块过");
			}
		}

	});
});