var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5PModules/AuthLogin','H5PModules/CloseAll',
	'../libs/mui.min', '../libs/jquery.min',
	'../libs/underscore-1.8.2'
];

define(deps, function(Ajax, Storage, AuthLogin,closeAll) {
	require(['../libs/jq.md5']);
	mui.plusReady(function() {
		AuthLogin.init();
		var indexPage = plus.webview.getLaunchWebview();
		var self = plus.webview.currentWebview();
		
		if(self.closeAll){
			closeAll();
		}
		if(self.changePsw){
			mui.openWindow({
				url: 'pages/p-forgetPassword.html',
				id: 'forgetPassword'
			});
		}
		
		//第三方登录
		function authLogin(type) {
			console.log("login authLogin");
			AuthLogin.authLogin(type, function(a) {
				console.log("login authLogin finished");
				var openType;
				var userInfo = a.userInfo;
				if (a.id == 'qq') {
					openType = 0;
				} else {
					openType = 1;
				}
				plus.nativeUI.showWaiting();
				Ajax.send('AppServer/member/doLogin.do', {
					type: 1, //第三方登录
					openId: userInfo.openid || a.authResult.openid,
					openType: openType, //0:QQ,1:weixin
					openName: userInfo.nickname,
					openHeadPath: userInfo.headimgurl || userInfo.figureurl_qq_2,
					cid: plus.storage.getItem('clientid'),
					token:plus.device.uuid
				}, function(data) {
					
					if(data.success && data.list.bindMobile){
						processUserData(data, true);
					}else if(data.success){
						goBindMobilePage(data);
					}else{
						console.log("error!");
					}
					plus.nativeUI.closeWaiting();
				});
			});
		}

		//第三方登录事件
		$('#do3Login_wexin').on('tap', function() {
			plus.nativeUI.showWaiting();
			authLogin('weixin');
		});
		$('#do3Login_qq').on('tap', function() {
			plus.nativeUI.showWaiting();
			authLogin('qq');
		});

		//登录
		$('#loginBtn').on('tap', function() {
			var mobile = $('#username').val();
			var password = $('#password').val();
			if(mobile.trim() == ''){
				plus.nativeUI.alert('请填写手机号!', function() {}, "壹块过");
			}else if(password.trim() == ''){
				plus.nativeUI.alert('请填写密码!', function() {}, "壹块过");
			}else{
				plus.nativeUI.showWaiting('登录中...');
				Ajax.send('AppServer/member/doLogin.do', {
					type: 0, //非第三方登录
					mobile: mobile,
					password: $.md5(password).toUpperCase(),
					cid: plus.storage.getItem('clientid'),
					token:plus.device.uuid
				}, function(data) {
					processUserData(data);
					plus.nativeUI.closeWaiting();
				});
			}
		});
		
		window.addEventListener("processUserData",function(e){
			var data = e.detail;
			console.log(JSON.stringify(data))
			processUserData(data,true);
		});
		
		function goBindMobilePage(data){
			mui.openWindow({
				url: 'pages/p-bindMobile.html',
				id: 'bindMobile',
				extras:{
					data:data
				}
			});
			
		}
		
		/**
		 * 处理登录接口返回的数据
		 * @param {Object} data
		 * @param {Object} isOpen 是否第三方
		 */
		function processUserData(data, isOpen) {
			if (data.success) {
				var user = data.list;
				if (isOpen != true && !!data.list.headPath) {
					user.headPath = data.serverPath + data.list.headPath;
				}else if(isOpen != true){
					user.headPath = "";
				}
				Storage.setObj('user', data.list);
				var userCenter = plus.webview.getWebviewById('userCenter');
				if (userCenter) {
					mui.fire(userCenter,"dorefresh");
				}
				//如果已经选过题库,跳转到考证页面
				if (plus.storage.getItem('NowBank-' + user.id) != null) {
					mui.fire(indexPage, 'change2criticism');
				}
				mui.ajax(Ajax.pollUrl + 'ajax/login', {
					data: {
						id: user.id,
						operateType: "login", 
						token: plus.device.uuid
					},
					dataType: 'json',
					type: 'POST',
					timeout: 20000,
					success: function(data) {
						console.log("token已被记录："+plus.device.uuid)
						mui.fire(plus.webview.getLaunchWebview(),'openSw');
						plus.nativeUI.closeWaiting();
						mui.back();
					},
					error: function(xhr, type, errorThrown) {
						if (xhr.status == 0) {
							console.log('网络不通,请检查网络设置.');
						} else if (xhr.status == 408) {
							console.log('请求超时,请检查网络设置.');
						} else {
							console.log("通讯失败:HTTP状态码:" + xhr.status);
						}
						plus.nativeUI.closeWaiting();
					}
				});
				self.close();
			} else {
				if(data.status == 103){
					plus.nativeUI.alert('用户名或密码错误!', function() {}, "壹块过");
				}else{
					plus.nativeUI.alert('登录失败!', function() {}, "壹块过");
				}
				plus.nativeUI.closeWaiting();
			}
		}

		//去注册页面
		$('#goRegister').on('tap', function() {
			mui.openWindow({
				url: 'pages/p-register.html',
				id: 'register'
			});
		});

		//显示第三方登录窗口
		$("#otherLogin").on('tap', function() {
			$('.otherLoginCtn').addClass('active');
		});

		//关闭第三方登录窗口
		$("#closeOtherLoginCtn").on('tap', function() {
			$('.otherLoginCtn').removeClass('active');
		});

		//忘记密码页面
		$("#forgetPsw").on('tap', function() {
			//				plus.nativeUI.alert('开发中', function() {}, "壹块过");
			//				return;
			mui.openWindow({
				url: 'pages/p-forgetPassword.html',
				id: 'forgetPassword'
			});
		});


	});
});