var deps = ['H5PModules/Ajax', 'H5PModules/Storage', '../libs/template',
	'H5PModules/ValiLogin', 'H5PModules/Location','Update',
	'../libs/mui.min', '../libs/jquery.min', '../libs/swiper/js/swiper.min'
];
define(deps, function(Ajax, Storage, template, valiLogin, Location, Update) {
	mui.plusReady(function() {
		plus.navigator.closeSplashscreen();
		plus.nativeUI.showWaiting('获取数据...');
		var swiperData;
		
		events();
		
		//地理定位
		Location.get();
		//如果没有定位
		setTimeout(function(){
			if(!Storage.getObj('location')){
				plus.nativeUI.alert('自动定位失败,可能由于当前网络或设备禁止定位,需要手动选择', function() {
					mui.openWindow({
						url: '../pages/p-changeLocation.html',
						id: 'changeLocation'
					});
				}, "壹块过");
			}
		},5000);
		//获取最新题库的列表
		Ajax.send('AppServer/tpackage/dlPackageList.do', {}, function(data) {
			plus.storage.setItem('serverPath', data.serverPath);
			if (data.success) {
				var html = template('newBanks-tp', data);
				$('#newBanks').html(html);
			} else {
				$('#newBanks').html('');
			}
			plus.nativeUI.closeWaiting();
		});
		//获取轮播
		Ajax.send('AppServer/home/queryResLink.do', {}, function(data) {
			swiperData = data;
			if (data.success) {
				var html = template('main-swiper-tp', data);
				$('#main-swiper-ctn').html(html);
				//轮播
				var swiper = new Swiper('.swiper-container', {
					pagination: '.swiper-pagination',
					autoplay: 2000
				});
			}
			plus.nativeUI.closeWaiting();
		});

		//检查更新
		Update.check(function(status){
			if(status != 2){
				//如果是最新版本,检查题库是否有更新
				hasNewPackageVer();
			}
		});
		//是否有题包更新
		function hasNewPackageVer() {
			var user = Storage.getObj('user');
			if(user == null){
				setTimeout(hasNewPackageVer,5000);
				return;
			}
			
			Ajax.send('AppServer/tpackage/findPayPackage.do', {
				memberId: user.id
			}, function(data) {
				if (data.success) {
					var list = data.list;
					var vers = [];
					for(var i=0;i<list.length;i++){
						var id = list[i].id;
						var subject = Storage.getObj('Bank-'+user.id+'-'+id+'-subjects');
						if(subject != null) {
							var packageVersion = subject.packageVersion;
							vers.push({
								id:id,
								packageVersion:packageVersion
							});
						}
					}
					findPackageVersion(vers);
				}
			});
		}
		
		function findPackageVersion(vers){
			Ajax.send('AppServer/tpackage/findPackageVersion.do',{
				packageMessage:JSON.stringify(vers)
			},function(data){
				if(data.status == 24) {
					var list = data.list;
					var serverPath = data.serverPath;
					for(var i = 0; i < list.length; i++) {
						var obj = list[i];
						if(obj.emblem) {
							plus.nativeUI.confirm("有题库更新,立即更新?", function(r) {
								if (r.index == 0) {
									$('#goMyQBankPage').trigger('tap');
								}
							}, "壹块过");
							break;
						}
					}
				}
			});
		}

		function events() {
			window.addEventListener('changeLocation', function(e) {
				var l = e.detail;
//美工把这里显示的字去掉了
//				$('.my-top-nav .location').text(l);
			});
			//最新题库的链接
			$('#newBanks').on('tap', '.item', function() {
				if (valiLogin()) {
					var opts = {
						id: $(this).data('id')
					};
					mui.openWindow({
						url: '../pages/p-bank-detail.html',
						id: 'bank-detail',
						extras: {
							opts: opts
						}
					});
				}
			});

			//公告页面
			$('#goNoticePage').on('tap', function() {
				mui.openWindow({
					url: '../pages/p-notice.html',
					id: 'notice'
				});
			});

			//切換城市
			$('#changeLocation').on('tap', function() {
				mui.openWindow({
					url: '../pages/p-changeLocation.html',
					id: 'changeLocation'
				});
			});

			//我的证书
			$('#goMyCertificatesPage').on('tap', function() {
//				plus.nativeUI.alert('此功能仍在开发中!', function() {}, "壹块过");
//				return;
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myCertificates.html',
						id: 'myCertificates'
					});
				}
			});

			//我的代购
			$('#goAgentPage').on('tap', function() {
//				plus.nativeUI.alert('此功能仍在开发中!', function() {}, "壹块过");
//				return;
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myAgent.html',
						id: 'myAgent',
						extras:{
							productType:1,  //1、代报名  2、题包  3、线下培训
							pageTitle:"代报名管理"
						}
					});
				}
			});

			//我的题库
			$('#goMyQBankPage').on('tap', function() {
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myQBank.html',
						id: 'myQBank'
					});
				}
			});

			//我的关注
			$('#goMyFollowPage').on('tap', function() {
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myFollowList.html',
						id: 'myFollowList'
					});
				}
			});

			//活动页面
			$('#goActivityPage').on('tap', function() {

				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-activity.html',
						id: 'activity'
					});
				}
			});

			//轮播点击
			$('#main-swiper-ctn').on('tap', '.swiper-slide', function() {
				var index = $(this).data('index');
				var obj = swiperData.list[index];
				var obj_reStructed = {
					serverPath: swiperData.serverPath,
					list: {
						name: obj.name,
						content: obj.content,
						publishTime: obj.createTime,
						imagePath: obj.imagePath
					}
				}
				mui.openWindow({
					url: '../pages/p-activityDetail.html',
					id: 'activityDetail',
					extras: {
						obj: obj_reStructed,
						flag: 'mainSwiper'
					}
				});
			});

		}

	});
});