var deps = ['H5PModules/Ajax', 'H5Modules/TemplateHelper', 'H5PModules/Storage', 'H5PModules/Pay',
	'HTMLs', '../libs/mui.min', '../libs/jquery.min'
];
define(deps, function(Ajax, template, Storage, Pay, HTMLs) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var user = Storage.getObj('user');
		var productType = self.parent().productType;
		productType = productType ? productType : "";

		var state;
		if (self.id == 'myAgent-all') {
			state = '';
		} else if (self.id == 'myAgent-obligation') {
			//待付款
			state = '1';
		}

		//		else if (self.id == 'myAgent-review') {
		//			//审核中
		//			state = '2';
		//		} else if (self.id == 'myAgent-receiving') {
		//			//待收货
		//			state = '3';
		//		} else if (self.id == "myAgent-reviewFailed") {
		//			//审核失败
		//			state = '4';
		//		} 
		else if (self.id == 'myAgent-receiving') {
			//待收货,已付款
			state = '2,3,4';
		} else if (self.id == "myAgent-refund") {
			//退款
			state = '5,6,7';
		}

		plus.nativeUI.showWaiting('加载中...');
		Ajax.send('AppServer/order/findOrderList.do', {
			memberId: user.id,
			state: state,
			productType: productType
		}, function(data) {
			if (data.status == 603) {
				if (data.list.length == 0) {
					$('#list-ctn').html(HTMLs.empty);
				} else {
					var html = template('list-tp', data);
					$('#list-ctn').html(html);
				}
			} else {
				$('#list-ctn').html(HTMLs.empty);
			}
			plus.nativeUI.closeWaiting();
		});

		$('#list-ctn').on('tap', '.cancel', cancelOrder);
		$('#list-ctn').on('tap', '.pay', doPay);
		$('#list-ctn').on('tap', '.edit', editOrder);
		$('#list-ctn').on('tap', '.monkeyBack', goRefundPage);
		$('#list-ctn').on('tap', '.mid', goOrderDetailPage);
		$('#list-ctn').on('tap', '.p_comment', goPostCommentPage);



		function goPostCommentPage() {
			var ordernum = $(this).data('ordernum');
			var ptype = $(this).data('ptype');
			var pid = $(this).data('pid');
			mui.openWindow({
				url: "../pages/p-myAgent-postComment.html",
				id: "myAgent-postComment",
				extras: {
					ordernum: ordernum,
					ptype: ptype,
					pid: pid
				}
			});
		}


		//去订单详情页面
		function goOrderDetailPage() {
			var ordernum = $(this).data('ordernum');
			mui.openWindow({
				url: "../pages/p-myOrderDetail.html",
				id: "myOrderDetail",
				extras: {
					ordernum: ordernum
				}
			});
		}

		//去退款页面
		function goRefundPage() {
			var ordernum = $(this).data('ordernum');
			var totalprice = $(this).data("totalprice");
			var refundMoney = $(this).data("realprice");
			var usePoint = $(this).data("usepoint");
			mui.openWindow({
				url: "../pages/p-myAgent-refund-detail.html",
				id: "myAgent-refund-detail",
				extras: {
					ordernum: ordernum,
					totalprice: totalprice,
					refundMoney: refundMoney,
					usePoint: usePoint
				}
			});

		}

		//编辑订单
		function editOrder() {
			var ordernum = $(this).data('ordernum');
			Ajax.send('AppServer/signup/findSignupByOrdernum.do', {
				memberId: user.id,
				ordernum: ordernum
			}, function(data) {
				if (data.success) {
					goOrderEdit(data.list);
				}
			});
		}

		//付款
		function doPay() {
			var ordernum = $(this).data('ordernum');
			Ajax.send('AppServer/order/gotoPayOrder.do', {
				ordernum: ordernum
			}, function(data) {
				if (data.status = 600) {
					var orderStr = data.list;
					var arr = orderStr.split("&");
					var payType;
					if (arr.indexOf('payment_type=1') != -1) {
						payType = 'alipay';
					} else {
						payType = 'wxpay';
					}
					Pay.doPay(data.list, payType, function() {
						//todo
					});
				} else {
					console.log(data.status);
				}
			});
		}

		//去修改页面
		function goOrderEdit(orderList) {
			mui.openWindow({
				url: '../pages/p-orderEdit.html',
				id: 'orderEdit',
				extras: {
					orderList: orderList
				}
			});
		}

		//取消订单
		function cancelOrder() {
			var ordernum = $(this).data('ordernum');
			var listItem = $(this).parent().parent();

			mui.confirm("确定取消?", "壹快过", function(e) {
				if (e.index == 0) {
					Ajax.send('AppServer/order/deleteOrder.do', {
						ordernum: ordernum
					}, function(data) {
						if (data.status == 604) {
							listItem.remove();
							mui.toast('删除成功!');
						} else {
							mui.toast('删除失败!');
						}
					});

				}
			});


		}


	});
});