var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5Modules/TemplateHelper', 'H5PModules/ValiLogin',
	'../libs/mui.min', '../libs/jquery.min'
];
define(deps, function(Ajax, Storage, template, valiLogin) {
	mui.plusReady(function() {
		window.addEventListener("dorefresh", function() {
			$("*").off("tap");
			READY2INIT();
		});
		READY2INIT();
	});
	
	
	function READY2INIT(){
		var user = Storage.getObj("user");
		var self = plus.webview.currentWebview();
		var pageNumber = 1;
		mui.init({
			pullRefresh: {
				container: "#refreshContainer",
				down: {
					callback: function() {
						pageNumber = 1;
						getList(pageNumber,function(){
							mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
						},true);
					}
				},
				up: {
					callback: function() {
						var t = this;
						getList(pageNumber + 1,function(data){
							var isEnd = false;
							if(!data.entity || data.entity.length == 0){
								isEnd = true;
							}
							t.endPullupToRefresh(isEnd);
							pageNumber++;
						});
					}
				}
			}
		});
		
		$('#listCtn').on("tap", ".l-ctn", goDetailPage);
		$('#listCtn').on("tap", ".pinglun", goDetailPage);
		$('#listCtn').on("tap", ".dianzan.canTap", function() {
			var self = this;
			if (valiLogin()) {
				dianzan(self);
			}
		});
		$('#listCtn').on("tap", ".dianzan.cancel", function(){
			var self = this;
			if(valiLogin()){
				cancelDianzan(self);
			}
		});
		
		getList(pageNumber,function(){});
		
		//点赞
		function dianzan(self) {
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/add.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i + 1);
					$t.attr("class","fr dianzan cancel");
					$t.find("img").attr("src","../img/community/iconfont-iconfontdianzan3.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}
		
		function cancelDianzan(self){
			var $t = $(self);
			var id = $(self).data("id");
			plus.nativeUI.showWaiting();
			Ajax.send("bbs/praise/del.do", {
				userId: user.id,
				topsId: id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var i = parseInt($t.find('span').text());
					$t.find('span').text(i - 1);
					$t.attr("class","fr dianzan canTap");
					$t.find("img").attr("src","../img/community/iconfont-dianzan.svg");
				} else {
					plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
				}
			});
		}
		
		//评论
		function goDetailPage() {
			var topsId = $(this).data("id");
			mui.openWindow({
				url: "../pages/p-community-detail.html",
				id: "community-detail",
				extras: {
					topsId: topsId
				}
			});
		}
		/**
		 * 获取数据
		 */
		function getList(pageNumber, callback, isReload) {
			plus.nativeUI.showWaiting("加载中...");
			Ajax.send("bbs/tops/topsList.do", {
				userId:user?user.id:"",
				pageNumber: pageNumber,
				pageSize: 10,
				sectionId: 6 //这个是板块id
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if (data.ret_code == 0) {
					var html = template("list-tp", data);
					if(isReload){
						$('#listCtn').html(html);
					}else{
						$('#listCtn').append(html);
					}
					if (callback) {
						callback(data);
					}
				} else {
					console.log(JSON.stringify(data));
				}
			});

		}

	
	}
});