var deps = ['H5PModules/Ajax', 'H5PModules/Storage', '../libs/template', 'H5PModules/Upload-image',
	'../libs/RegExps', '../libs/mui.min', '../libs/jquery.min'
]
define(deps, function(Ajax, Storage, template, UploadImage) {
	mui.plusReady(function() {
		window.addEventListener("dorefresh", function() {
			$("*").off("tap");
			READY2INIT();
		});
		READY2INIT();
	});
	
	function READY2INIT(){
		var user = Storage.getObj('user');
		var self = plus.webview.currentWebview();
		$('#submit').on('tap', submitIt);
		$('#uploadImg').on('tap', uploadImg);
		$('#major').on('change',findCertByMajor);
		$('#imgs').on('tap', '.userimg', removeImg);

		getMajor();

		function getMajor() {
			plus.nativeUI.showWaiting("加载专业列表...");
			Ajax.send("AppServer/jobCert/findMajor.do", {}, function(data) {
				plus.nativeUI.closeWaiting();
				if(data.success){
					var html = template("select-major-tp", data);
					$("#major").html(html);
				}else{
					console.log(JSON.stringify(data));
				}
			});
		}
		
		function findCertByMajor(){
			plus.nativeUI.showWaiting("加载证书列表...");
			var majorId = $('#major').find('option:selected').data('id');
			Ajax.send("AppServer/jobCert/findCertByMajor.do", {
				majorId:majorId
			}, function(data) {
				plus.nativeUI.closeWaiting();
				if(data.success){
					var html = template("select-certs-tp", data);
					$("#certs").html(html);
				}else{
					console.log(JSON.stringify(data));
				}
			});
			
			
		}


		function removeImg() {
			var t = $(this);
			plus.nativeUI.confirm("确认删除此图片?", function(r) {
				if (r.index == 0) {
					t.remove();
				}
			}, "壹块过");
		}

		function uploadImg() {
			var num = $('.imgs .userimg').length; //除去按钮
			if (num > 0) {
				plus.nativeUI.alert('最多上传1张!', function() {}, '壹块过');
			} else {
				UploadImage.galleryImg(Ajax.serverUrl + '/AppServer/home/uploadImage.do', 'memberImage', function(obj) {
					var imageName = obj.list.imageName;
					var imageServerPath = obj.list.imageServerPath;
					$('.imgs').prepend('<img class="userimg" alt="' + imageName + '" src="' + imageServerPath + '"/>');
				});
			}
		}
		
		function submitIt(){
			var certId = $('#certs').find('option:selected').data('id');
			var certName = $('#certs').find('option:selected').text();
			var imagePath = $('.userimg').attr("alt");
			var description = "";
			Ajax.send("AppServer/memberCert/insertMemberCert.do",{
				memberId:user.id,
				certId:certId,
				certName:certName,
				imagePath:imagePath,
				description:description,
				publishType:1  // 1、已有证书  2、正在考 3、晒证
			},function(data){
				if(data.success){
					var gotV = plus.webview.getWebviewById("myCertificates-got");
					if(gotV){
						mui.fire(gotV,"dorefresh");
					}
					mui.alert(data.msg,"壹快过",function(){
						self.close();
					});
				}else{
					console.log(JSON.stringify(data));
				}
			});
		}


	
	}
});