var deps = ['H5PModules/Storage', 'H5PModules/Ajax', 'SwipeDelBtn', '../libs/template', 'HTMLs',
	'DownloadBank',
	'../libs/mui.min',
	'../libs/jquery.min', '../libs/underscore-1.8.2'
];

define(deps, function(Storage, Ajax, delBtn, template, HTMLs, DownloadBank) {
	mui.plusReady(function() {
		window.addEventListener("dorefresh", function() {
			$("*").off("tap");
			READY2INIT();
		});
		READY2INIT();
	});
	
	
	function READY2INIT(){
		
		var indexPage = plus.webview.getLaunchWebview();
		var user = Storage.getObj('user');
		var nowBankId = plus.storage.getItem('NowBank-' + user.id);

		plus.nativeUI.showWaiting('加载中...');
		Ajax.send('AppServer/tpackage/findPayPackage.do', {
			memberId: user.id
		}, function(data) {
			if (data.success) {
				if (data.list != null && data.list.length != 0) {
					var html = template('list-tp', data);
					$('#list-ctn').html(html);
					compVers();
				} else {
					$('#list-ctn').html(HTMLs.empty_goFind("下题包"));
				}
			} else {

			}
			delBtn.init('.innerList', 80);
			bindUse();
			plus.nativeUI.closeWaiting();
		});



		//获取版本,比对
		function compVers() {
			var vers = [];
			$('.innerList .useBtn').each(function() {
				var t = $(this);
				var id = t.data('id');
				var subject = Storage.getObj('Bank-' + user.id + '-' + id + '-subjects');
				if (subject != null) {
					var packageVersion = subject.packageVersion;
					vers.push({
						id: id,
						packageVersion: packageVersion
					});
				}

			});
			Ajax.send('AppServer/tpackage/findPackageVersion.do', {
				packageMessage: JSON.stringify(vers)
			}, function(data) {
				if (data.status == 24) {
					var list = data.list;
					var serverPath = data.serverPath;
					for (var i = 0; i < list.length; i++) {
						var obj = list[i];
						if (obj.emblem) {
							var t = $('.useBtn[data-id="' + obj.id + '"]');
							t.html('更新');
							t.addClass('update');
							t.removeClass('used');
						}
					}
				}
			});
		}


		//判断是否使用中
		function bindUse() {
			$('.innerList .useBtn').each(function() {
				var t = $(this);
				if (t.data('id') == nowBankId) {
					t.addClass('used');
					t.text('使用中');
				} else {
					t.removeClass('used');
					t.text('使用');
				}
			});
		}
		
		$("#list-ctn").on('tap', '#goFind', function() {
			mui.fire(plus.webview.getLaunchWebview(),"change2find");
			mui.back();
		});

		//使用题库
		$('#list-ctn').on('tap', '.useBtn', function() {
			var id = $(this).data('id');
			var $theBtn = $(this);
			if ($theBtn.hasClass('update')) {
				// 直接更新
				var path = $theBtn.attr('dlpath');
				//显示进度
				$('#bar-text_' + id + ',#bar-ctn_' + id).show();
				DownloadBank.do(path, id, function() {
					plus.nativeUI.closeWaiting();
					//隐藏进度
					$('#bar-text_' + id + ',#bar-ctn_' + id).hide();
					if(!!plus.webview.getWebviewById('criticism')){
						mui.fire(plus.webview.getWebviewById('criticism'),"dorefresh");
					}
					plus.nativeUI.alert('更新完成!', function() {
						mui.back();
					}, "壹块过");
				}, function(download, w) {
					//进度状况
					var loadSize = download.downloadedSize; //已完成下载文件的大小
					var totalSize = download.totalSize; //下载任务文件的总大小
					var n = (loadSize / totalSize * 100).toFixed(0);
					var loadSizeM = (loadSize / 1024 / 2024).toFixed(2);
					var totalSizeM = (totalSize / 1024 / 2024).toFixed(2);
					$('#loadSizeM_' + id).text(loadSizeM);
					$('#totalSizeM_' + id).text(totalSizeM);
					$('#bar-ctn_' + id).find('.bar').css('width', n + '%');
				});

			} else {
				if (!plus.storage.getItem('Bank-' + user.id + '-' + id + '-titles')) {
					plus.nativeUI.confirm("题库未下载,是否现在下载?", function(r) {
						if (r.index == 0) {
							// 直接下载
							var path = $theBtn.attr('dlpath');
							//显示进度
							$('#bar-text_' + id + ',#bar-ctn_' + id).show();
							DownloadBank.do(path, id, function() {
								plus.nativeUI.closeWaiting();
								//隐藏进度
								$('#bar-text_' + id + ',#bar-ctn_' + id).hide();
								useIt();
								plus.nativeUI.alert('下载完成!', function() {
									mui.back();
								}, "壹块过");
							}, function(download, w) {
								//进度状况
								var loadSize = download.downloadedSize; //已完成下载文件的大小
								var totalSize = download.totalSize; //下载任务文件的总大小
								var n = (loadSize / totalSize * 100).toFixed(0);
								var loadSizeM = (loadSize / 1024 / 2024).toFixed(2);
								var totalSizeM = (totalSize / 1024 / 2024).toFixed(2);
								$('#loadSizeM_' + id).text(loadSizeM);
								$('#totalSizeM_' + id).text(totalSizeM);
								$('#bar-ctn_' + id).find('.bar').css('width', n + '%');
							});

						}
					}, "壹块过");
				} else {
					useIt();
					//返回
					plus.nativeUI.alert('题库切换成功!快去答题吧~', function() {
						mui.back();
					}, "壹块过");
				}

				//使用题库
				function useIt() {
					plus.storage.setItem('NowBank-' + user.id, id.toString());
					mui.fire(indexPage, 'change2criticism');
					var criticism = plus.webview.getWebviewById('criticism');
					if (criticism) {
						mui.fire(criticism,"dorefresh");
					}
					//使用中效果
					nowBankId = id.toString();
					bindUse();
				}
			}
		});

		//删除题库
		$('#list-ctn').on('tap', '.delBtn', function() {
			var self = $(this);
			var id = self.data('id');
			plus.nativeUI.confirm("确认删除?", function(r) {
				if (r.index == 0) {
					plus.nativeUI.showWaiting();
					//删除服务端
					Ajax.send('AppServer/tpackage/updatePackageStatus.do', {
						id: id,
						memberId: user.id
					}, function(data) {
						if (data.status == 22) {
							//删除本地
							var nowBank = plus.storage.getItem('NowBank-' + user.id);
							if (nowBank == id) {
								plus.storage.removeItem('NowBank');
							}
							var oldBankIndex = Storage.getObj('BankIndex-' + user.id);
							var newBankIndex = _.filter(oldBankIndex, function(obj) {
								return obj.id != id;
							});
							Storage.setObj('BankIndex-' + user.id, newBankIndex);

							plus.storage.removeItem('Bank-' + user.id + '-' + id + '-titles');
							plus.storage.removeItem('Bank-' + user.id + '-' + id + '-errors');
							plus.storage.removeItem('Bank-' + user.id + '-' + id + '-favList');
							plus.storage.removeItem('NowBank-' + user.id);

							self.parent().remove();
							plus.nativeUI.closeWaiting();
						} else {
							plus.nativeUI.alert('删除失败!状态:' + data.status, function() {}, "壹块过");
							plus.nativeUI.closeWaiting();
						}
					});

				}
			}, "壹块过");

		});

	
	}
});