var deps = ['H5PModules/Ajax', 'H5PModules/Storage', 'H5PModules/Pay',
	'../libs/mui.min', '../libs/jquery.min',
];
define(deps, function(Ajax, Storage, Pay) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var user = Storage.getObj("user");
		var productName = self.productName;
		var price = self.price;
		var order = self.order;
		var packData = self.packData ? self.packData : null;
		var signup = self.signup ? self.signup : null;
		var real, pointInfo;
		var useScoreLimit = 0;

		findPointInfo();
		setVals();
		setTimeout(function(){
			initEvents();
		},300);

		function setVals() {
			$('#productName').text(productName);
			$('#price').text(price + "元");
			$(".realPay").text("实际支付:¥"+price);
			$('.jifen').show();
		}

		function initEvents() {
			$('#submit').on('tap', submit);
			
			$("#how2get").on("tap",function(){
				mui.openWindow({
					url:'../pages/p-sharePage.html',
					id:"sharePage"
				});
			});
			
			$("#isUseScore").on("tap",function(){
				if($(this).hasClass("active")){
					$(this).attr("src","../img_v2/pay/swich0.png");
					$(this).removeClass("active");
					$(".realPay").text("实际支付:¥"+price);
				}else{
					$(this).attr("src","../img_v2/pay/swich1.png");
					$(this).addClass("active");
					$(".realPay").text("实际支付:¥"+(price-$("#useScore").text()).toFixed(2));
				}
			});
			
			$('.payModeList').on('tap', function() {
				$('.payModeList').removeClass('active');
				$('.payModeList .selectImg').attr("src","../img_v2/pay/select0.png");
				$(this).addClass('active');
				$(this).find(".selectImg").attr("src","../img_v2/pay/select1.png");
			});
			
		}
		
		//逗币信息
		function findPointInfo(){
			plus.nativeUI.showWaiting();
			Ajax.send("AppServer/order/findPointInfo.do",{
				memberId: user.id,
				productType: order.productType
			},function(data){
				plus.nativeUI.closeWaiting();
				if(data.success){
					pointInfo = {
						point : data.list.point,
						percent : data.list.pointPercentage
					};
					var pointLimit = (price  * (pointInfo.percent / 100)).toFixed(1);
					//向上取整,有小数就整数部分加1 
					if(parseFloat(pointLimit) > 1.0 || parseFloat(price) > 1.0){
						pointLimit =Math.ceil(pointLimit);
					}
					
					$("#totalScore").text(data.list.point);
					
//					$("#limitedScore").text(pointLimit);
					//设置使用积分，如果拥有逗币小于可使用逗币，设置使用逗币为拥有逗币
					if(parseInt(data.list.point) >= pointLimit){
						useScoreLimit = pointLimit;
					}else{
						useScoreLimit = parseInt(data.list.point);
					}
					$("#useScore").text(useScoreLimit);
				}
			});
			
		}

		function submit() {
			var useScore = parseFloat($("#useScore").text());
			if($("#isUseScore").hasClass("active")){
				order.usePoint = useScore;
			}else{
				order.usePoint = 0;
			}
			var mode = $('.payModeList.active').data('mode');
			if (!mode) {
				plus.nativeUI.alert("请选择支付方式", function() {}, '壹块过');
				return;
			}
			plus.nativeUI.showWaiting();
			if (mode == 'alipay') {
				order.payType = 1;
			} else if (mode == 'wxpay') {
				order.payType = 2;
			}
			//获取订单
			Ajax.send('AppServer/order/insertOrder.do', {
				order: JSON.stringify(order),
				signup: JSON.stringify(signup)
			}, function(data) {
				if (data.status == 601) {
					plus.nativeUI.closeWaiting();
					Pay.doPay(data.list, mode, function() {
						if(self.noCallback){
							noCallback(data);
						}else{
							callback(data);
						}
					}, function() {
						noCallback();
					});
				} else {
					plus.nativeUI.alert("支付异常，请重试", function() {}, '壹块过');
				}
			});
			function callback(data) {
				var bankDetail = plus.webview.getWebviewById('bank-detail');
				var jigouBaoming = plus.webview.getWebviewById('find-jigou-baoming');
				if (bankDetail) {
					mui.fire(bankDetail, 'downPackeg', {
						data: packData
					});
				}
				if (jigouBaoming) {
					mui.fire(jigouBaoming, 'payCallback', data);
				}
				mui.back();
			}
			function noCallback(data) {
				if (plus.webview.getWebviewById("find-detail-list-baoming-dbm-detail")) {
					plus.webview.getWebviewById("find-detail-list-baoming-dbm-detail").close();
				}
				if (plus.webview.getWebviewById("find-detail-list-baoming-dbm")) {
					plus.webview.getWebviewById("find-detail-list-baoming-dbm").close();
				}
				mui.openWindow({
					url: '../pages/p-myAgent.html',
					id: 'myAgent',
					extras:{
						pageTitle:"我的订单"
					}
				});
			}
			//取消订单
			function cancelOrder(ordernum) {
				Ajax.send('AppServer/order/deleteOrder.do', {
					ordernum: ordernum
				}, function(data) {});
			}
		}
	});
});