var deps = ['H5PModules/Storage', 'H5Modules/TemplateHelper','H5PModules/ValiLogin',
	'H5PModules/Share', '../libs/underscore-1.8.2', '../libs/swiper/js/swiper.min'
];

define(deps, function(Storage, template,valiLogin, Share) {
	Share.init();
	var user = Storage.getObj('user');
	window.nowIndex = 0;
	var self = plus.webview.currentWebview();
	var examObj = self.examObj;
	var bankId = plus.storage.getItem('NowBank-' + user.id);
	var q_error = self.q_error;
	var q_right = self.q_right;
	//筛选出错题
	var DataList = _.filter(self.DataList, function(obj) {
		return q_error.indexOf(obj.id) != -1;
	});
	$('#numTotal').text(DataList.length);
	self.orgId = DataList[0].orgId;

	if (DataList.length == 0) {
		plus.nativeUI.alert('题库为空!', function() {
			mui.back();
		}, "壹块过");
		return;
	}

	plus.nativeUI.showWaiting('加载题库...');

	readBank();

	//收藏当前题目
	$('#favIt').on('tap', favIt);
	$('#unFavIt').on('tap', unFavIt);
	//纠错
	$('#reportError').on('tap', reportError);

	//分享
	$('#shareIt').on('tap', toggleShareWindow);
	$('#shareWindow .cancel').on('tap', toggleShareWindow);
	$('#shareWindow .btns img').on('tap', function(){
		var $self = $(this);
		if(valiLogin()){
			processShare();
		}
	});

	function reportError() {
		var qid = DataList[nowIndex].id;
		mui.openWindow({
			url: '../pages/p-reportError.html',
			id: 'reportError',
			extras: {
				opts: {
					titleId: qid,
					memberId: user.id,
					orgId: self.orgId,
					areaCode: DataList[0].areaCode
				}
			}
		});
	}

	//显示分享窗口
	function toggleShareWindow() {
		$('#shareMask,#shareWindow').toggle();
	}

	//处理分享
	function processShare($self) {
		var qid = DataList[nowIndex].id;
		var serverPath = plus.storage.getItem('serverPath');
		var type = $self.data('type');
		var view = $self.data('view');
		//“sinaweibo”表示新浪微博、“tencentweibo”表示腾讯微博、“weixin”表示微信、“qq”表示腾讯QQ。
		var infoList = {
			title: '壹块过 - 试题练习',
			content: "这道题出的有水准！",
			href: serverPath + '/AppServer/titleRelease/findTitleDetailModel.do?areaCode=' + DataList[0].areaCode + '&titleId=' + qid + '&isIOS=' + mui.os.ios + '&memberId=' + user.id + '&type=moni' + "&time=" + new Date().getTime()
		};
		if (type == 'weixin') {
			infoList.extra = {
				scene: view
			};
		}
		Share.shareAction(type, infoList);
	}

	function unFavIt() {
		var qid = DataList[nowIndex].id;
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		favList = _.difference(favList, [qid]);
		Storage.setObj('Bank-' + user.id + '-' + bankId + '-favList', favList);
		$(this).hide();
		$('#favIt').show();

	}

	function favIt() {
		var qid = DataList[nowIndex].id;
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		if (favList == null) {
			favList = [qid];
		} else {
			favList = _.union(favList, [qid]);
		}
		Storage.setObj('Bank-' + user.id + '-' + bankId + '-favList', favList);
		$(this).hide();
		$('#unFavIt').show();

	}


	/**
	 * 读题库文件
	 */
	function readBank() {
			//如果需要筛选错题
			renderIndex(DataList);
			for (var i = 0; i < DataList.length; i++) {
				renderQuestions(DataList[i]);
			}

			window.mySwiper = new Swiper('.swiper-container', {
				onTransitionEnd: function(swiper) {
					$('#numNow').text(swiper.activeIndex + 1);
					nowIndex = swiper.activeIndex;
					changeFavBtn(nowIndex);
				}
			});
			var height = $(window).height() - 65;
			$('.swiper-slide').height(height);

			changeFavBtn(0);
			plus.nativeUI.closeWaiting();
		}
		/**
		 * 控制收藏和取消收藏
		 * @param {Object} nowIndex
		 */

	function changeFavBtn(nowIndex) {
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		var qid = DataList[nowIndex].id;
		if (favList == null) {
			$('#favIt').show();
			$('#unFavIt').hide();
			return;
		}
		if (favList.indexOf(qid) == -1) {
			$('#favIt').show();
			$('#unFavIt').hide();
		} else {
			$('#favIt').hide();
			$('#unFavIt').show();
		}
	}

	/**
	 * 渲染题库
	 * @param {Object} index
	 */
	function renderQuestions(question) {
		var html = '';
		if (question.titleType === "0000") {
			html = template('singleSelect-tp', {
				q: question
			});
		} else if (question.titleType === "0001") {
			html = template('multipleSelect-tp', {
				q: question
			});
		} else if (question.titleType === "0002") {
			html = template('decide-tp', {
				q: question
			});
		} else if (question.titleType === "0003") {
			html = template('analysis-tp', {
				q: question
			});
		}
		$('#swiper-wrapper').append('<div class="swiper-slide">' + html + '</div>');
	}

	/**
	 * 渲染题目的目录
	 */
	function renderIndex(data) {
		//		$('#numTotal').text('/' + data.length);
		var indexArray = [];
		var indexHtml = template('question_index_tp', {
			list: data
		});
		$('#question_index').html(indexHtml);
	}

	return {
		DataList: DataList
	};
});