var deps = ['H5PModules/Storage', 'H5Modules/TemplateHelper', '../libs/moment.min',
	'H5PModules/Share','H5PModules/ValiLogin',
	'../libs/underscore-1.8.2', '../libs/swiper/js/swiper.min'
];

define(deps, function(Storage, template, moment, Share, valiLogin) {
	Share.init();
	var user = Storage.getObj('user');
	window.nowIndex = 0;
	var self = plus.webview.currentWebview();
	var examObj = self.examObj;
	var bankId = plus.storage.getItem('NowBank-' + user.id);
	//获取过滤的题库
	var filteredBank = Storage.getObj('filteredBank');
	//组合数据
	var DataList = [];
	pushList2DataList(filteredBank.danxuan);
	pushList2DataList(filteredBank.duoxuan);
	pushList2DataList(filteredBank.panduan);
	pushList2DataList(filteredBank.anlifenxi);
	self.orgId = DataList[0].orgId;

	if (DataList.length == 0) {
		plus.nativeUI.alert('题库为空!', function() {
			mui.back();
		}, "壹块过");
		return;
	}

	plus.nativeUI.showWaiting('加载题库...');

	template.helper('$getScore', function(type) {
		if (type == '0000') {
			return examObj.danxuanScore;
		} else if (type == '0001') {
			return examObj.duoxuanScore;
		} else if (type == '0002') {
			return examObj.panduanScore;
		} else if (type == '0003') {
			return examObj.anlifenxiScore;
		}
	});


	readBank();

	//计时
	window.leftTime = moment.duration(examObj.examTime, 'minutes');
	var second = moment.duration(1, 'seconds');
	var _ti = setInterval(function() {
		if (leftTime.get('hours') != 0) {
			$('#leftTime').text(leftTime.get('hours') + ":" + leftTime.get('minutes') + ':' + leftTime.get('seconds'));
		} else {
			$('#leftTime').text(leftTime.get('minutes') + ':' + leftTime.get('seconds'));
		}
		if (leftTime.get('hours') == 0 && leftTime.get('minutes') == 0 && leftTime.get('seconds') == 0) {
			clearInterval(_ti);
			$('#submit').trigger('timeOver');
		} else {
			leftTime = leftTime.subtract(second);
		}
	}, 1000);

	//收藏当前题目
	$('#favIt').on('tap', favIt);
	$('#unFavIt').on('tap', unFavIt);
	//纠错
	$('#reportError').on('tap', reportError);

	//分享
	$('#shareIt').on('tap', toggleShareWindow);
	$('#shareWindow .cancel').on('tap', toggleShareWindow);
	$('#shareWindow .shareBtn').on('tap', function(){
		var $self = $(this);
		if(valiLogin()){
			processShare($self);
		}
	});


	function reportError() {
		var qid = DataList[nowIndex].id;
		mui.openWindow({
			url: '../pages/p-reportError.html',
			id: 'reportError',
			extras: {
				opts: {
					titleId: qid,
					memberId: user.id,
					orgId: self.orgId,
					areaCode: DataList[0].areaCode
				}
			}
		});
	}

	//显示分享窗口
	function toggleShareWindow() {
		$('#shareMask,#shareWindow').toggle();
	}

	//处理分享
	function processShare($self) {
		var qid = DataList[nowIndex].id;
		var serverPath = plus.storage.getItem('serverPath');
		var type = $self.data('type');
		var view = $self.data('view');
		//“sinaweibo”表示新浪微博、“tencentweibo”表示腾讯微博、“weixin”表示微信、“qq”表示腾讯QQ。
		var infoList = {
			title: '壹块过 - 试题练习',
			content: "这道题出的有水准！",
			href: serverPath + '/AppServer/titleRelease/findTitleDetailModel.do?areaCode=' + DataList[0].areaCode + '&titleId=' + qid + '&isIOS=' + mui.os.ios + '&memberId=' + user.id + '&type=moni' + "&time=" + new Date().getTime()
		};
		if (type == 'weixin') {
			infoList.extra = {
				scene: view
			};
		}
		Share.shareAction(type, infoList);
	}

	function unFavIt() {
		var qid = DataList[nowIndex].id;
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		favList = _.difference(favList, [qid]);
		Storage.setObj('Bank-' + user.id + '-' + bankId + '-favList', favList);
		$(this).hide();
		$('#favIt').show();

	}

	function favIt() {
		var qid = DataList[nowIndex].id;
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		if (favList == null) {
			favList = [qid];
		} else {
			favList = _.union(favList, [qid]);
		}
		Storage.setObj('Bank-' + user.id + '-' + bankId + '-favList', favList);
		$(this).hide();
		$('#unFavIt').show();

	}

	function pushList2DataList(list) {
		for (var i = 0; i < list.length; i++) {
			DataList.push(list[i]);
		}
	}

	//	function getResult(index) {
	//		var $nowSlide = $('.swiper-slide').eq(index);
	//		var $radio = $nowSlide.find('.my-radio-btn.active');
	//		var answer = $radio.parent().parent().data('answer');
	//		if ($radio.data('value') == answer) {
	//			$radio.attr('class', 'my-radio-btn active success');
	//		} else {
	//			$radio.attr('class', 'my-radio-btn active error');
	//		}
	//		var $checkboxes = $nowSlide.find('.my-checkbox-btn.active');
	//		$checkboxes.each(function() {
	//			$checkbox = $(this);
	//			var answer = $checkbox.parent().parent().data('answer');
	//			var value = $checkbox.data('value');
	//			if (answer.indexOf(value) == -1) {
	//				$checkbox.attr('class', 'my-checkbox-btn active error');
	//			} else {
	//				$checkbox.attr('class', 'my-checkbox-btn active success');
	//			}
	//		});
	//
	//	}

	/**
	 * 读题库文件
	 */
	function readBank() {
			//如果需要筛选错题
			renderIndex(DataList);
			for (var i = 0; i < DataList.length; i++) {
				renderQuestions(DataList[i]);
			}

			window.mySwiper = new Swiper('.swiper-container', {
				onTransitionEnd: function(swiper) {
						$('#numNow').text(swiper.activeIndex + 1);
						nowIndex = swiper.activeIndex;
						changeFavBtn(nowIndex);
					}
					//				onTransitionStart:function(swiper){
					//					getResult(nowIndex);
					//				}
			});
			var height = $(window).height() - 65;
			$('.swiper-slide').height(height);
			changeFavBtn(0);
			plus.nativeUI.closeWaiting();
		}
		/**
		 * 控制收藏和取消收藏
		 * @param {Object} nowIndex
		 */

	function changeFavBtn(nowIndex) {
		var favList = Storage.getObj('Bank-' + user.id + '-' + bankId + '-favList');
		var qid = DataList[nowIndex].id;
		if (favList == null) {
			$('#favIt').show();
			$('#unFavIt').hide();
			return;
		}
		if (favList.indexOf(qid) == -1) {
			$('#favIt').show();
			$('#unFavIt').hide();
		} else {
			$('#favIt').hide();
			$('#unFavIt').show();
		}
	}

	/**
	 * 渲染题库
	 * @param {Object} index
	 */
	function renderQuestions(question) {
		var html = '';
		if (question.titleType === "0000") {
			html = template('singleSelect-tp', {
				q: question
			});
		} else if (question.titleType === "0001") {
			html = template('multipleSelect-tp', {
				q: question
			});
		} else if (question.titleType === "0002") {
			html = template('decide-tp', {
				q: question
			});
		} else if (question.titleType === "0003") {
			html = template('analysis-tp', {
				q: question
			});
		}
		$('#swiper-wrapper').append('<div class="swiper-slide">' + html + '</div>');
	}

	/**
	 * 渲染题目的目录
	 */
	function renderIndex(data) {
		$('#numTotal').text('/' + data.length);
		var indexArray = [];
		var indexHtml = template('question_index_tp', {
			list: data
		});
		$('#question_index').html(indexHtml);
	}

	return {
		DataList: DataList
	};
});