var deps = ['H5PModules/Ajax','H5PModules/Storage', '../libs/moment.min',
	'../libs/underscore-1.8.2', '../libs/mui.min', '../libs/jquery.min'
];

define(deps, function(Ajax, Storage, moment) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var user = Storage.getObj('user');
		var bankId = plus.storage.getItem('NowBank-' + user.id);
		var examObj = self.examObj;
		require(['Questions-exam-render', 'Questions-exam-index'], function(QRender) {
			//考试信息框
			var startTest = plus.webview.getWebviewById('startTest');
			if (startTest) {
				//关闭考试信息框
				startTest.close();
			}

			//单选的处理
			$('#swiper-wrapper').on('tap', '.my-radio-ctn', function() {
				var $btn = $(this).find('.my-radio-btn');
				var $ctn = $btn.parent().parent();
//				if ($ctn.hasClass('disabled')) {
//					return;
//				}
				$ctn.find('.my-radio-btn').removeClass('active');
				$btn.addClass('active');
//				$ctn.addClass('disabled');
				changeColor();
			});
			//多选选择处理
			$('#swiper-wrapper').on('tap', '.my-checkbox-ctn', function() {
				var $btn = $(this).find('.my-checkbox-btn');
				if ($btn.hasClass('active')) {
					$btn.removeClass('active');
				} else {
					$btn.addClass('active');
				}
				changeColor();
			});


			//交卷
			$('#submit').on('tap', function() {
				plus.nativeUI.confirm("确定交卷?", function(r) {
					if (r.index == 0) {
						process();
					}
				}, "壹块过");
			});
			
			$('#submit').on('timeOver',function(){
				process();
				plus.nativeUI.closeWaiting();
			});

			//处理交卷
			function process() {
				var waitingBox = plus.nativeUI.showWaiting('处理中...');
				//				$('#backdrop').show();
				var q_right = [],
					q_error = [],
					score_sum = 0;
				var $selects = $('.selects');
				//每组题
				$selects.each(function() {
					judge($(this));
				});
				//存错误
				storeErrors();


				storeExamResults();

				function storeExamResults() {
					//生成记录对象
					var totalTime = moment.duration(examObj.examTime, 'minutes');
					var usedTime = totalTime.subtract(window.leftTime);
					var examResult = {
						//用时
						usedTime: usedTime.get('minutes') + '分' + usedTime.get('seconds') + '秒',
						//得分
						score: score_sum,
						//用户名
						username: user.nickName,
						//及格分
						passScore: examObj.passScore,
						//测试名
						examName: examObj.examName,
						//总分
						totalPoint: examObj.totalPoint,
						date: moment().format('YYYY-MM-DD'),
						memberId: user.id
					};
					var ExamResults = Storage.getObj('ExamResults-' + user.id);
					if (ExamResults == null) {
						ExamResults = [];
					}
					ExamResults.unshift({
						examResult: examResult
//						DataList: QRender.DataList,
//						q_error: q_error,
//						q_right: q_right,
//						uuid:uuid()
					});
					Storage.setObj('ExamResults-' + user.id, ExamResults);
					
					
					
					//上传考试记录
					var state;//是否及格
					if(examResult.score >= examResult.passScore){
						state = 0;
					}else{
						state = 1;
					}
					waitingBox.setTitle('上传数据中...');
					Ajax.send('AppServer/memberExam/addExamResult.do',{
						memberId:user.id,
						score:examResult.score,
						usedTime:usedTime.get('minutes')*60 + usedTime.get('seconds'),
						state:state,
						examId:self.examId
					},function(data){
						waitingBox.close();
						if(data.success){
							var resultId = data.list;
							showResultPage(examResult,resultId);
						}else{
							console.log(JSON.stringify(data));
						}
					});
					
					
				}

				/**
				 * 显示得分页面
				 * @param {Object} examResult
				 */
				function showResultPage(examObj,resultId) {
					var url, id, flag;
					if (examObj.totalPoint == examObj.score) {
						//满分
						url = '../pages/p-score-100.html';
						id = 'score-100';
						flag = 100;
					} else if (examObj.score >= examObj.passScore) {
						//及格
						url = '../pages/p-score-60.html';
						id = 'score-60';
						flag = 60;
					} else {
						//不及格
						url = '../pages/p-score-0.html';
						id = 'score-0';
						flag = 0;
					}
					var q_error_u = _.uniq(q_error);//去重
					var q_right_u = _.uniq(q_right);//去重
					var q_right_u = _.difference(q_right_u,q_error_u);//求差
					mui.openWindow({
						url: url,
						id: id,
						extras: {
							examResult: examObj,
							DataList: QRender.DataList,
							q_error: q_error_u,
							q_right: q_right_u,
							flag: flag,
							resultId:resultId
						}
					});
				}

				/**
				 * 记录错误
				 */
				function storeErrors() {
					//记录题目状态到本地
					var errors = Storage.getObj('Bank-' + user.id + '-' + bankId + '-errors');
					if (errors == null) {
						Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', q_error);
					} else {
						var union = _.union(errors, q_error);
						Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', union);
					}
				}

				/**
				 * 判断对错
				 * @param {Object} $select	JQ元素
				 */
				function judge($select) {
					var $parent = $select.parent();
					var answer = $select.data('answer');
					//替换录入的所有空格以及中文逗号
					answer = answer.replace(/\s/g, "");
					answer = answer.replace(/，/g, ",");
					var score = $select.data('score');
					var $avs = $select.find('.my-radio-btn.active,.my-checkbox-btn.active');
					var v = [];
					var vStr = '';
					//选项
					if($avs.length == 0){
						//未答
						return;
					}
					$avs.each(function() {
						v.push($(this).data('value'));
					});
					vStr = v.join(',');
					if (vStr == answer) {
						if($parent.hasClass('analysis-qlist')){
							//如果是案例分析,特殊处理
							q_right.push($parent.data('qid'));
						}else{
							q_right.push($select.data('qid'));
						}
						score_sum += score;
					} else if (vStr == '') {

					} else {
						if($parent.hasClass('analysis-qlist')){
							//如果是案例分析,特殊处理
							q_error.push($parent.data('qid'));
						}else{
							q_error.push($select.data('qid'));
						}
					}
				}

			}
		});
		
		//改已答题目的颜色
		function changeColor(){
			var act = $('#swiper-wrapper .swiper-slide').eq(window.nowIndex).find('.active');
			if(act.length > 0){
				$('#question_index .span6>div').eq(window.nowIndex).css({
					'background':'#aaa'
				});
			}
		}


		function uuid() {
			var s = [];
			var hexDigits = "0123456789abcdef";
			for (var i = 0; i < 36; i++) {
				s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
			}
			s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
			s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
			s[8] = s[13] = s[18] = s[23] = "-";

			var uuid = s.join("");
			return uuid;
		}

		mui.back = function() {
			plus.nativeUI.confirm("确定放弃本次考试?", function(r) {
				if (r.index == 0) {
					plus.webview.currentWebview().close();
				}
			}, "壹块过");
		}
	});
});