var deps = ['H5PModules/Storage', 'H5PModules/Ajax', 'H5Modules/TemplateHelper', '../libs/moment.min',
	'../libs/underscore-1.8.2', '../libs/mui.min', '../libs/jquery.min'
];
define(deps, function(Storage, Ajax, template, moment) {
	mui.plusReady(function() {
		var user = Storage.getObj('user');
		var bankId = plus.storage.getItem('NowBank-' + user.id);
		require(['Questions-pra-render', 'Questions-pra-index'], function(render) {
			var q_right_count = 0, //正确数
				q_error_count = 0, //错误数
				q_left_count = render.filteredList.length; //总题数
			//单选的处理
			$('#swiper-wrapper').on('tap', '.my-radio-ctn', processRadios);
			//多选选择处理
			$('#swiper-wrapper').on('tap', '.my-checkbox-ctn', processCheckboxes);
			//查看解析,针对多选
			$('#swiper-wrapper').on('tap', '.watchAnswer', processWatches);
			//回复
			$("#addComment").on("tap", function() {
				var $comment = $('.swiper-slide-active').find(".comment").parent();
				var qid = $comment.attr('id').split("_")[1];
				var commentText = $('#commentText').val();
				if (commentText.trim() == "") {
					plus.nativeUI.alert("回复内容不能为空！", function() {}, '壹块过');
				} else {
					addComments(qid, commentText);
				}

			});
			//显示更多评论
			$('.absCtn').on("tap", ".showMoreComments", function() {
				var qid = $(this).attr("qid");
				mui.openWindow({
					url: "../pages/p-comments.html",
					id: "comments",
					extras: {
						qid: qid
					}
				});
			});

			function processWatches() {
				var $btn = $(this);
				var qid = $btn.data('qid');
				var answer = $('#selects-' + qid).data('answer');
				//替换录入的所有空格以及中文逗号
				answer = answer.replace(/\s/g, "");
				answer = answer.replace(/，/g, ",");
				var answerList = answer.split(',');
				var $analysisBox = $('#analysisBox-' + qid);
				var $choice = $('#selects-' + qid).find('.my-checkbox-btn.active');
				var choiceList = [],
					choiceStr = '';

				if ($btn.text() == '解析') {
					$btn.addClass('hide');
					$analysisBox.removeClass('hide');
					return;
				}

				for (var i = 0; i < $choice.length; i++) {
					var value = $($choice[i]).data('value');
					choiceList.push(value);
					//处理按钮显示样式
					if (answerList.indexOf(value) != -1) {
						$($choice[i]).attr('class', 'my-checkbox-btn success');
					} else {
						$($choice[i]).attr('class', 'my-checkbox-btn error');
					}
				}
				choiceStr = choiceList.join(',');


				//做错,记录到本地
				var _RorE = ''
				var elist = Storage.getObj('Bank-' + user.id + '-' + bankId + '-errors');
				if (elist == null) {
					elist = [];
				}
				if (answer != choiceStr) {
					elist.push(qid);
					Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', _.uniq(elist));
					_RorE = '你答错了';
					$analysisBox.find('.result').addClass('error');
					q_error_count++;

					//显示评论
					var $comment = $('.swiper-slide-active').find(".commentCtn");
					$comment.show();
					$('#c_inputbox').show();

				} else {
					//					elist = _.difference(elist, [qid]);
					//					Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', elist);
					_RorE = '你答对了';
					$analysisBox.find('.result').addClass('success');
					q_right_count++;
				}
				//分析框的处理
				$btn.addClass('hide');
				$analysisBox.removeClass('hide');
				$analysisBox.find('.result').html(_RorE);
				$('#r_e_count_div .right').text(q_right_count);
				$('#r_e_count_div .error').text(q_error_count);
				$('#r_e_count_div .unknow').text(q_left_count - q_right_count - q_error_count);


				//缓存处理
				var order = $(this).data('index');
				if ($(this).parent().hasClass('swiper-slide')) {
					window.oldHtmls[order - 1] = $(this).parent().html();
				} else {
					window.oldHtmls[order - 1] = $(this).parent().parent().html();
				}

				//获取显示评论
				var $comment = $('.swiper-slide-active').find(".commentCtn");
				var qid = $comment.attr('id').split("_")[1];
				showCommemts(qid);

			}

			function processCheckboxes() {
				var $btn = $(this).find('.my-checkbox-btn');
				if ($btn.hasClass('active')) {
					$btn.removeClass('active');
				} else {
					$btn.addClass('active');
				}
			}

			function processRadios() {
				var $btn = $(this).find('.my-radio-btn');
				var $ctn = $btn.parent().parent();
				if ($ctn.hasClass('disabled')) {
					return;
				}
				$ctn.find('.my-radio-btn').removeClass('active');
				$btn.addClass('active');
				var qid = $btn.data('qid');
				var $analysisBox = $('#analysisBox-' + qid);
				var answer = $('#selects-' + qid).data('answer');
				var value = $btn.data('value');
				var _RorE = ''
				var elist = Storage.getObj('Bank-' + user.id + '-' + bankId + '-errors');
				if (elist == null) {
					elist = [];
				}

				if (answer.trim() == value.trim()) {
					//					elist = _.difference(elist, [qid]);
					//					Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', elist);
					_RorE = '你答对了';
					$analysisBox.find('.result').addClass('success');
					q_right_count++;
					$btn.attr('class', 'my-radio-btn success');
				} else {
					elist.push(qid);
					Storage.setObj('Bank-' + user.id + '-' + bankId + '-errors', _.uniq(elist));
					_RorE = '你答错了';
					$analysisBox.find('.result').addClass('error');
					q_error_count++;
					$btn.attr('class', 'my-radio-btn error');

					//显示评论
					var $comment = $('.swiper-slide-active').find(".commentCtn");
					$comment.show();
					$('#c_inputbox').show();
				}
				$analysisBox.find('.result').text(_RorE);
				$analysisBox.removeClass('hide');
				$ctn.addClass('disabled');
				$('#r_e_count_div .right').text(q_right_count);
				$('#r_e_count_div .error').text(q_error_count);
				$('#r_e_count_div .unknow').text(q_left_count - q_right_count - q_error_count);


				//缓存处理
				var order = $ctn.parent().find('.q-type').data('index');
				window.oldHtmls[order - 1] = $ctn.parent().html();

				//获取显示评论
				var $comment = $('.swiper-slide-active').find(".commentCtn");
				var qid = $comment.attr('id').split("_")[1];
				showCommemts(qid);
			}


			/**
			 * 回复
			 * @param {Object} qid
			 * @param {Object} rcontent
			 */
			function addComments(qid, rcontent) {
				plus.nativeUI.showWaiting();
				Ajax.send("bbs/replys/addReplys.do", {
					userId: user.id,
					numb: $('#comment_' + qid).find("li").length,
					stId: qid,
					rcontent: rcontent,
					sectionId: 1
				}, function(data) {
					plus.nativeUI.closeWaiting();
					if (data.ret_code == 0) {
						var obj = {
							nickName: user.nickName,
							rcontent: data.entity.rcontent,
							headimg: data.entity.img,
							createdate: data.entity.createdate
						};
						var html = template("comment-li-tp", obj);
						$('#comment_' + qid).find("ul").prepend(html);
						$('#comment_' + qid).find(".emptyComment").hide();
						$('#commentText').val("");
					} else {
						console.log(data.fail_desc);
						plus.nativeUI.alert(data.fail_desc, function() {}, '壹块过');
					}
				});
			}


			/**
			 * 显示评论
			 * @param {Object} qid
			 */
			function showCommemts(qid) {
				if ($('.swiper-slide-active').find(".comment").length == 0) {
					$('#comment_' + qid).html('<div style="padding:10px;text-align:center;">评论加载中...</div>');
					Ajax.send("bbs/replys/seeReplys.do", {
						stId: qid,
						sectionId: 1,
						pageNumber: 1,
						pageSize: 5
					}, function(data) {
						data.qid = qid;
						if (data.ret_code == 0) {
							var html = template("comment-tp", data);
							$('#comment_' + qid).html(html);

							//判断是否显示评论框框
							var $comment = $('.swiper-slide-active').find(".commentCtn");
							if ($comment.css('display') == "none") {
								$('#c_inputbox').hide();
							} else {
								$('#c_inputbox').show();
							}
						}
					});
				}

			}


		});
	});
});