var deps = ['H5PModules/Ajax', '../libs/RegExps', '../libs/mui.min',
	'../libs/jquery.min', '../libs/underscore-1.8.2'
];
define(deps, function(Ajax) {
	require(['../libs/jq.md5']);
	mui.plusReady(function() {

		events();

		function events() {
			$('#doRegister').on('tap', doRegister);
			$('#getCode').on('tap', getCode);
			$('.checkbox').on('tap', function() {
				var t = $(this);
				if (t.hasClass('active')) {
					t.removeClass('active');
				} else {
					t.addClass('active');
				}
			});
			$('#goLicensePage').on('tap', function() {
				mui.openWindow({
					url: '../pages/p-license.html',
					id: 'license'
				});
			});
		}

		function getCode() {
			var obj = {
				mobile: $('#mobile').val()
			};
			if (obj.mobile.trim() == '') {
				plus.nativeUI.alert('手机号码为空', function() {}, '壹块过');
			} else if (!RegExps.Mobile.test(obj.mobile.trim())) {
				plus.nativeUI.alert('手机号码格式有误', function() {}, '壹块过');
			} else {
				plus.nativeUI.showWaiting();
				Ajax.send('AppServer/home/sms.do', {
					operateType:"1",//1：注册 2、修改密码
					smsType: 0, //0:发送 1:匹配 2:删除
					mobile: $('#mobile').val()
				}, function(data) {
					plus.nativeUI.closeWaiting();
					if (data.status == 9) {
						plus.nativeUI.alert('手机号码为空!', function() {}, '壹块过');
					} else if (data.status == 10) {
						plus.nativeUI.alert('发送失败!', function() {}, '壹块过');
					} else if (data.status == 11) {
						$('#getCode').off('tap', getCode);
						var sec = 120;
						var $getCode = $('#getCode');
						var i = setInterval(function() {
							$getCode.text(sec);
							if (sec == 0) {
								clearInterval(i);
								$getCode.text('获取验证码');
								$('#getCode').on('tap', getCode);
							} else {
								sec--;
							}
						}, 1000);
						plus.nativeUI.alert('发送成功!', function() {}, '壹块过');

					} else if (data.status == 12) {
						plus.nativeUI.alert('匹配成功!', function() {}, '壹块过');
					} else if (data.status == 13) {
						plus.nativeUI.alert('匹配失败!', function() {}, '壹块过');
					} else if (data.status == 14) {
						plus.nativeUI.alert('验证码失效!', function() {}, '壹块过');
					} else if (data.status == 15) {
						plus.nativeUI.alert('没有此验证码信息!', function() {}, '壹块过');
					} else if (data.status == 101) {
						plus.nativeUI.alert('手机账号已注册!', function() {}, '壹块过');
					}
				});
			}
		}

		function doRegister() {
			//检测是否同意条款
			var checkbox = $('.licenseInfo .checkbox');
			if(!checkbox.hasClass('active')){
				plus.nativeUI.alert('需要先同意条款和政策', function() {}, '壹块过');
				return;
			}
			
			//表单数据
			var obj = {
				mobile: $('#mobile').val(),
				nickName: $('#nickName').val(),
				password: $.md5($('#password').val()).toUpperCase()
			};
			if ($('#password').val().trim() == '') {
				plus.nativeUI.alert('密码不能为空', function() {}, '壹块过');
			} else if ($('#password').val() != $('#rePassword').val()) {
				plus.nativeUI.alert('密码不一致', function() {}, '壹块过');
			} else if (obj.mobile.trim() == '') {
				plus.nativeUI.alert('手机号码为空', function() {}, '壹块过');
			} else if (obj.nickName.trim() == '') {
				plus.nativeUI.alert('昵称为空', function() {}, '壹块过');
			} else if (!RegExps.Mobile.test(obj.mobile.trim())) {
				plus.nativeUI.alert('手机号码格式有误', function() {}, '壹块过');
			} else if($('#codeInput').val().trim() == ''){
				plus.nativeUI.alert('验证码不能为空', function() {}, '壹块过');
			} else{
				plus.nativeUI.showWaiting();
				valiCode(function(flag) {
					plus.nativeUI.closeWaiting();
					if (flag) {
						//发送注册信息
						plus.nativeUI.showWaiting();
						Ajax.send('AppServer/member/doRegistered.do', obj, function(data) {
							plus.nativeUI.closeWaiting();
							if (data.status == 100) {
								plus.nativeUI.alert('注册成功', function() {
									mui.back();
								}, '壹块过');
							} else if (data.status == 101) {
								plus.nativeUI.alert('注册失败,账号已存在', function() {}, '壹块过');
							} else if (data.status == 0) {
								plus.nativeUI.alert('系统异常', function() {}, '壹块过');
							}
						});
					}
				});
			}
		}


		/**
		 * 验证验证码
		 * @param {Object} callback
		 */
		function valiCode(callback) {
			Ajax.send('AppServer/home/sms.do', {
				smsType: 1, //0:发送 1:匹配 2:删除
				mobile: $('#mobile').val(),
				code: $('#codeInput').val()
			}, function(data) {
				var flag = false;
				if (data.status == 9) {
					plus.nativeUI.alert('手机号为空!', function() {}, '壹块过');
				} else if (data.status == 10) {
					//					plus.nativeUI.alert('发送失败!', function() {}, '壹块过');
				} else if (data.status == 11) {
					//					plus.nativeUI.alert('发送成功!', function() {}, '壹块过');
				} else if (data.status == 12) {
					//					plus.nativeUI.alert('匹配成功!', function() {}, '壹块过');
					flag = true;
				} else if (data.status == 13) {
					plus.nativeUI.alert('匹配失败!', function() {}, '壹块过');
				} else if (data.status == 14) {
					plus.nativeUI.alert('验证码失效!', function() {}, '壹块过');
				} else if (data.status == 15) {
					plus.nativeUI.alert('没有此验证码信息!', function() {}, '壹块过');
				}
				callback(flag);
			});
		}
	});
});