var deps = ['H5PModules/Ajax', 'H5PModules/Storage','H5Modules/TemplateHelper','HTMLs',
	'../libs/mui.min', '../libs/jquery.min',
	'../libs/underscore-1.8.2'
];

define(deps, function(Ajax, Storage, template,HTMLs) {
	mui.plusReady(function() {
		plus.nativeUI.showWaiting('加载中...');
		var self = plus.webview.currentWebview();
		var activeId = self.activeId;
		var user = self.user;
		var bankId = plus.storage.getItem('NowBank-' + user.id);
		
		//题包信息
		var BankObj = Storage.getObj('Bank-' + user.id + '-' + bankId + '-titles');
		
		//科目信息
		var subjects = Storage.getObj('Bank-' + user.id + '-' + bankId + '-subjects');
		
		if (BankObj == null || subjects == null) {
			$('#ctn').html(HTMLs.empty);
			return;
		}
		//类型
		var packageType = subjects.packageType;
		subjects = subjects.subjects;
		
		//当前科目
		var subject = _.find(subjects,function(obj){
			return obj.id == activeId;
		});
		
		
		//考试ID
		var examId = subject.examId;
//		var BankExtras = Storage.getObj('Bank-' + user.id + '-' + bankId + '-extras');

		var examObj;
		if (BankObj == null) {
			$('#ctn').html(HTMLs.empty);
			return;
		}
		//获取题目
		var DataList = _.find(BankObj.titles,function(obj){
			return obj.subjectId == activeId;
		});
		
		
		
		
		if (DataList == undefined || DataList.titles.length == 0) {
			plus.nativeUI.closeWaiting();
			$('#ctn').html(HTMLs.empty);
			return;
		}
		
		// 获取试题列表
		DataList = DataList.titles;
//		console.log("DataList ...");
//		console.log(JSON.stringify(DataList));
		var orgId = DataList[0].orgId;
		var opts = {};
		if(packageType == 2){
			opts.id = examId;
		}else{
			opts.orgId = orgId; //机构id
			opts.subjectId = self.activeId;//科目id
		}
		
		Ajax.send('AppServer/exam/findExamList.do',opts , function(data) {
			if (data.success) {
				examObj = data.list[0];
				var html = template('tp',{
					examObj:examObj,
					username:user.nickName,
					headimg:user.headPath
				});
				$('#ctn').html(html);
				var filteredBank = getQuestions(examObj.danxuanTotal, examObj.duoxuanTotal, examObj.panduanTotal, examObj.anlifenxiTotal);
				Storage.setObj('filteredBank', filteredBank);
			} else {
				$('#ctn').html(HTMLs.empty);
			}
			plus.nativeUI.closeWaiting();
		});

		/**
		 * 抽题
		 * @param {Object} danxuanTotal
		 * @param {Object} duoxuanTotal
		 * @param {Object} panduanTotal
		 * @param {Object} anlifenxiTotal
		 */
		function getQuestions(danxuanTotal, duoxuanTotal, panduanTotal, anlifenxiTotal) {
			var danxuan = [];
			var duoxuan = [];
			var panduan = [];
			var anlifenxi = [];
			for (var i = 0; i < DataList.length; i++) {
				if (DataList[i].titleType == '0000') {
					danxuan.push(DataList[i]);
				} else if (DataList[i].titleType == '0001') {
					duoxuan.push(DataList[i]);
				} else if (DataList[i].titleType == '0002') {
					panduan.push(DataList[i]);
				} else if (DataList[i].titleType == '0003') {
					anlifenxi.push(DataList[i]);
				}
			}

			return {
				danxuan: _.sample(danxuan, danxuanTotal),
				duoxuan: _.sample(duoxuan, duoxuanTotal),
				panduan: _.sample(panduan, panduanTotal),
				anlifenxi: _.sample(anlifenxi, anlifenxiTotal)
			};
		}

		$('#ctn').on('tap','#start', function() {
			//		plus.nativeUI.alert('此功能仍在开发中!',function(){},"壹块过");
			//		return;
			mui.openWindow({
				url: '../pages/p-questions.html',
				id: 'questions',
				extras: {
					flag: 'simulation', //模拟练习
					examObj: examObj,
					examId:examId
				}
			});
		});

	});
});