var deps = ['H5PModules/Download', 'H5PModules/Ajax'];

define(deps, function(Download, Ajax) {

	function check(callback) {
		//从manifest.json取版本信息
		plus.runtime.getProperty(plus.runtime.appid, function(info) {
			update(info.version,callback);
		});
	}

	function update(version,callback) {
		var versionType;
		if (mui.os.ios) {
			versionType = 'IOS';
		} else {
			versionType = 'android';
		}
		Ajax.send('AppServer/version/findVersion.do', {
			versionType: versionType, //IOS,android
			currentVersion: version
		}, function(data) {
			if(callback){
				callback(data.status);
			}
			if (data.status == 2) {
				var url = data.serverPath + data.list.url;
				plus.nativeUI.confirm("发现新版本，是否下载?", function(r) {
					if (r.index == 0) {
						mui.toast('已开始下载\n下载完成后将自动安装...');
						Download.start(url, function(d) {
							var path = d.filename;
							plus.nativeUI.showWaiting('更新中...',{back:'none'});
							plus.runtime.install(path, {force: true}, function() {
								console.log("安装wgt文件成功！");
								plus.cache.clear( function () {
									console.log( "Clear application cache successful!" );
								});
								plus.nativeUI.alert('壹块过更新成功,需要重新启动.', function() {
									plus.runtime.restart();
								}, "壹块过");
								plus.nativeUI.closeWaiting();
							}, function(e) {
								console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
								plus.nativeUI.alert(e.message, function() {}, "壹块过");
								plus.nativeUI.closeWaiting();
							});
						});
					}
				}, "壹块过");
			}
		});

	}

	return {
		check: check
	};
});