var deps = ['H5PModules/Upload-image', 'H5PModules/Ajax', 'H5PModules/Storage',
	'H5PModules/ValiLogin',"../libs/moment.min", 'H5PModules/AuthLogin',
	'../libs/jquery.min', '../libs/mui.min'
];
define(deps, function(UploadImg, Ajax, Storage, valiLogin,moment, AuthLogin) {
	mui.plusReady(function() {
		window.addEventListener("dorefresh", function() {
			$("*").off("tap");
			READY2INIT();
		});

		AuthLogin.init();
		READY2INIT();

	});

	function READY2INIT() {
		var user = Storage.getObj('user');
		var self = plus.webview.currentWebview();
		if (user == null) {
			$('#username').text("未登录");
			$("#jf_text").text("");
			$('#goLoginPage').show();
			$('#doLogout').hide();
			$("#goAgentPage").hide();
		} else {
			$('#username').text(user.nickName);
			$('#goLoginPage').hide();
			$('#doLogout').show();
			$("#goAgentPage").show();
		}

		//用户头像
		if (user != null && !!user.headPath) {
			if (user.headPath.indexOf("http://") == -1) {
				user.headPath = Ajax.serverUrl + user.headPath;
			}
			$('#uploadHeadimg').attr('src', user.headPath);
		} else {
			$('#uploadHeadimg').attr('src', "../img/common/head.svg");
		}

		events();
		findMember();


		require(['../libs/jquery.calendar-widget'], function() {
			var d = new Date();
			renderCalendar(d.getMonth(), d.getYear() - 100 + 2000);

			function renderCalendar(month, year) {
				$("#calendar").calendarWidget({
					month: month,
					year: year
				});
			}
		});

		function findMember() {
			if (user) {
				Ajax.send('AppServer/member/findMember.do', {
					memberId: user.id
				}, function(data) {
					if (data.success) {
						var p = data.list.point;
						$('#jf_text').text(p);
					}
				});
			}
		}


		/**
		 * 是否已签到
		 * @param {Object} userid
		 */
		function isSignin(userid) {
			Ajax.send('AppServer/signin/findSigninTime.do', {
				memberId: userid
			}, function(data) {
				if (data.status == 18) {
					Storage.setObj('signin-' + userid, data.list);
					$("#doSign").hide();
				} else {
				}
				plus.nativeUI.closeWaiting();
			});
		}
		//上传用户头像

		function uploadImg() {
			UploadImg.galleryImg(Ajax.serverUrl + '/AppServer/home/uploadImage.do', 'memberImage', function(obj) {
				Ajax.send('AppServer/member/doEdit.do', {
					memberId: user.id,
					memberFace: obj.list.imageName
				}, function(data) {
					if (data.success) {
						user = data.list;
						user.headPath = data.serverPath + user.headPath;
						$('#uploadHeadimg').attr('src', user.headPath);
						Storage.setObj('user', user);
						plus.nativeUI.alert('修改成功!', function() {}, '壹块过');
					} else {
						plus.nativeUI.alert('修改失败!', function() {}, '壹块过');
					}
				});
			});

		}

		function events() {
			//注销
			$('#doLogout').on('tap', function() {
				plus.nativeUI.confirm("确认注销?", function(r) {
					console.log(r.index);
					if (r.index == 0) {
						AuthLogin.logoutAll();
						plus.storage.removeItem('user');
						mui.fire(self, "dorefresh");
					}
				}, "壹块过");
			});
			//上传用户头像
			$('#uploadHeadimg').on('tap', function() {
				if (!valiLogin()) {
					return;
				}
				uploadImg();
			});
			//用户编辑页面
			$('#goUserDetailPage,#goEditPage').on('tap', function() {
				if (!valiLogin()) {
					return;
				}
				mui.openWindow({
					url: '../pages/p-userDetail.html',
					id: 'userDetail'
				});
			});
			//社交页面
			$('#goSocialPage').on('tap', function() {
				if (!valiLogin()) {
					return;
				}
				mui.openWindow({
					url: '../pages/p-socialSector.html',
					id: 'socialSector'
				});
			});
			//我的题库
			$('#goMyQBankPage').on('tap', function() {
				if (!valiLogin()) {
					return;
				}
				mui.openWindow({
					url: '../pages/p-myQBank.html',
					id: 'myQBank'
				});
			});
			//登录页面
			$('#goLoginPage').on('tap', function() {
				mui.openWindow({
					url: '../login.html',
					id: 'login'
				});
			});

			//签到
			$('#showSign').on('tap', function() {
				if (!user) {
					plus.nativeUI.alert('未登录', function() {}, '壹块过');
					return;
				}
				plus.nativeUI.showWaiting('获取签到数据...');
				Ajax.send('AppServer/signin/findSigninList.do', {
					memberId: user.id,
					signinTime:moment().format('YYYY-MM-DD HH:mm:ss')
				}, function(data) {
					if (data.status == 16) {
						Storage.setObj('signin-' + user.id, data.list);
						showCalendar();
					} else {
						plus.nativeUI.alert('获取失败!', function() {}, '壹块过');
					}
					plus.nativeUI.closeWaiting();
				});

			});
			$('#calendar-mask').on('tap', function() {
				$(this).hide();
			});
			window.addEventListener('closeCalendar', function() {
				$('#calendar-mask').hide();
			});

			//我的设置
			$('#goSettingsPage').on('tap', function() {
				mui.openWindow({
					url: '../pages/p-mySettings.html',
					id: 'mySettings'
				});
			});

			//我的订单
			$('#goAgentPage').on('tap', function() {
				if (valiLogin()) {
					mui.openWindow({
						url: '../pages/p-myAgent.html',
						id: 'myAgent',
						extras: {
							pageTitle: "我的订单"
						}
					});
				}
			});
			
			$('#doSign').on('tap', function() {
				if (valiLogin()) {
					doSign();
				}
			});

		}

		//增加积分
		function addCount(memberId) {
			Ajax.send('AppServer/member/point/signin.do', {
				memberId: memberId
			}, function(data) {
				if (data.success) {
					Storage.setObj('user', data.list);
					$('#jf_text').text(data.list.point);
				}
			});
		}

		function doSign() {
			plus.nativeUI.showWaiting('签到中...');
			Ajax.send('AppServer/signin/doSignin.do', {
				memberId: user.id
			}, function(data) {
				if (data.status == 4) {
					Storage.setObj('signin-' + user.id, data.list);
					$('#doSign>div').text('已签到');
					addCount(user.id);
				} else {
					plus.nativeUI.alert('签到失败!', function() {}, '壹块过');
				}
				plus.nativeUI.closeWaiting();
			});
		}

		//显示日历
		function showCalendar() {
			isSignin(user.id);
			var signinList = Storage.getObj('signin-' + user.id);
			for (var i = 0; i < signinList.length; i++) {
				var time = signinList[i].signinTime;
				var day = parseInt(time.split('-')[2]);
				$('.current-month.day' + day).css({
					'color': '#1b85f2',
					'font-weight': 'bold'
				});
				var today = new Date().getUTCDate();
				$('.current-month.day' + today).css({
					'color': '#fff',
					'background': '#1b85f2',
					'font-weight': 'bold'
				});
			}
			$('#calendar-mask').show();
		}

	}
});